diff --git a/README.md b/README.md
index fc25c173e..18b7d0c48 100644
--- a/README.md
+++ b/README.md
@@ -2,7 +2,6 @@ Tcpreplay
 =========
 [![Build Status](https://travis-ci.org/appneta/tcpreplay.svg?branch=master)](https://travis-ci.org/appneta/tcpreplay)
 [![Coverity Scan Build Status](https://scan.coverity.com/projects/12017/badge.svg)](https://scan.coverity.com/projects/12017)
-[![Code Climate](https://codeclimate.com/github/appneta/tcpreplay.png)](https://codeclimate.com/github/appneta/tcpreplay)
 [![Codacy Badge](https://api.codacy.com/project/badge/Grade/0e49d208c69e440182ba21109ecaf31d)](https://www.codacy.com/app/fklassen/tcpreplay?utm_source=github.com&utm_medium=referral&utm_content=appneta/tcpreplay&utm_campaign=badger)
 [![Website](https://img.shields.io/website-up-down-green-red/http/shields.io.svg)](http://tcpreplay.appneta.com)
 
diff --git a/configure.ac b/configure.ac
index fa9eef70b..3987fc711 100644
--- a/configure.ac
+++ b/configure.ac
@@ -4,7 +4,7 @@ dnl $Id$
 AC_PREREQ([2.69])
 
 dnl Set version info here!
-AC_INIT([tcpreplay],[4.3.0-beta1],
+AC_INIT([tcpreplay],[4.3.0-beta2],
     [https://github.com/appneta/tcpreplay/issues],
     [tcpreplay],
     [http://tcpreplay.sourceforge.net/])
@@ -1291,7 +1291,6 @@ dnl ###########################################################
 if test "x$NETMAPINCDIR" != "x"; then
     OLDCPPFLAGS="$CPPFLAGS"
     CPPFLAGS="$CPPFLAGS -DNETMAP_WITH_LIBS -DND -I$NETMAPINCDIR"
-    AC_CHECK_HEADERS(stdio.h net/netmap_user.h)
 
     have_nm_open=no
     have_nm_nr_reg_mask=no
@@ -1492,12 +1491,13 @@ dnl If doesn't exist, we'll define them in src/common/fakepcap.h
 AC_MSG_CHECKING(for DLT_LINUX_SLL in libpcap)
 AC_TRY_COMPILE([#include "$LPCAPINC"],
                [ int foo;
-                 foo = DLT_LINUX_SLL ],
-                [ AC_DEFINE([HAVE_DLT_LINUX_SLL], [1],
-                            [Does pcap.h include a header with DLT_LINUX_SLL?])
-                  AC_MSG_RESULT(yes)
-                ],
-                AC_MSG_RESULT(no)
+                 foo = DLT_LINUX_SLL
+               ],
+               [ AC_DEFINE([HAVE_DLT_LINUX_SLL], [1],
+                           [Does pcap.h include a header with DLT_LINUX_SLL?])
+                 AC_MSG_RESULT(yes)
+               ],
+               [AC_MSG_RESULT(no)]
                )
 
 AC_MSG_CHECKING(for DLT_C_HDLC in libpcap)
@@ -1547,22 +1547,29 @@ for testfile in $LPCAPINCDIR/pcap/bpf.h $LPCAPINCDIR/pcap-bpf.h ; do
                 AC_SUBST(PCAP_BPF_H_FILE)
                 AC_DEFINE([INCLUDE_PCAP_BPF_HEADER], [1],
                         [What is the path (if any) to the libpcap bpf header file?])
-                AC_MSG_RESULT($testfile)
-            ],
-            AC_MSG_RESULT(no)
+            ]
             )
     fi
 done
 
+if test $foundbpfheader != no; then
+    AC_MSG_RESULT($testfile)
+else
+    AC_MSG_RESULT(no)
+fi
+
 dnl ## Test for netmap-libpcap
 have_pcap_netmap=no
 if test $foundpcap != no ; then
+	AC_MSG_CHECKING(for netmap libpcap)
     PCAP_NETMAP_C_FILE="$LPCAPINCDIR/pcap-netmap.c"
     if test -f "${PCAP_NETMAP_C_FILE}" ; then
         AC_DEFINE([HAVE_LIBPCAP_NETMAP], [1],
                                    [Does this version of libpcap support netmap?])
-        AC_MSG_RESULT(yes)
         have_pcap_netmap=yes
+        AC_MSG_RESULT(yes)
+    else
+        AC_MSG_RESULT(no)
     fi
 fi
 
diff --git a/docs/CHANGELOG b/docs/CHANGELOG
index 9bc26cc75..015102068 100644
--- a/docs/CHANGELOG
+++ b/docs/CHANGELOG
@@ -1,11 +1,26 @@
+10/18/2018 Version 4.3.0 beta2
+    - fix issues identifed by Codacy (#493)
+    - CVE-2018-17974 heap-buffer-overflow dlt_en10mb_encode (#486)
+    - CVE-2018-17582 heap-buffer-overflow in get_next_packet (#484)
+    - CVE-2018-13112 heap-buffer-overflow in get_l2len (#477 dup #408)
+
 01/18/2018 Version 4.3.0 beta1
     - Travis CI build fails due to new build images (#432)
     - Unable to build with libpcap 1.8.1 (#430)
+    - tcpprep -S not working for large cache files (#423)
+    - Unable to tcprewrite range of ports with --portmap (#422)
+    - --maxsleep broken for values less than 1000 (#421)
+    - Avoid non-blocking behaviour when using STDIN (#416)
+    - pcap containing >1020 packets produces invalid cache file (#415)
     - heap-buffer-overflow in get_l2protocol (#410)
     - heap-buffer-overflow in packet2tree (#409)
     - heap-buffer-overflow in get_l2len (#408)
     - heap-buffer-overflow in flow_decode (#407)
+    - Rewrite zero IP total length field to match the actual packet length (#406)
     - stack-buffer-overflow in tcpcapinfo (#405)
+    - tcpprep --include option does not exclude (#404)
+    - Negative-size-param memset in dlt_radiotap_get_80211 (#402)
+    - tcpeplay --verbose option not working (#398)
 
 05/10/2017 Version 4.2.6
     - Test fails on sparc64 (#393)
@@ -42,7 +57,7 @@
     - Packet destortion --fuzz-seed option by Gabriel Ganne (#302)
     - Add --unique-ip-loops option to modify IPs every few loops (#296)
     - Netmap startup delay increase (#290)
-    - tcpcapinfo buffer overflow vulnerablily (#278)
+    - CVE-2017-6429 tcpcapinfo buffer overflow vulnerablily (#278)
     - Update git-clone instructions by Kyle McDonald (#277)
     - Allow fractions for --pps option (#270)
     - Print per-loop stats with --stats=0 (#269)
diff --git a/libopts/nested.c b/libopts/nested.c
index db4c052ab..24b154975 100644
--- a/libopts/nested.c
+++ b/libopts/nested.c
@@ -783,12 +783,23 @@ optionLoadNested(char const * text, char const * name, size_t nm_len)
             text = scan_name(text, res_val);
 
         else switch (*text) {
-        case NUL: goto scan_done;
-        case '<': text = scan_xml(text, res_val);
-                  if (text == NULL) goto woops;
-                  if (*text == ',') text++; break;
-        case '#': text = strchr(text, NL);  break;
-        default:  goto woops;
+        case NUL:
+            goto scan_done;
+
+        case '<':
+            text = scan_xml(text, res_val);
+            if (text == NULL)
+                goto woops;
+            if (text[0] == ',')
+                text++;
+            break;
+
+        case '#':
+            text = strchr(text, NL);
+            break;
+
+        default:
+            goto woops;
         }
     } while (text != NULL); scan_done:;
 
diff --git a/src/common/cache.c b/src/common/cache.c
index 15d260c67..c29eeda04 100644
--- a/src/common/cache.c
+++ b/src/common/cache.c
@@ -271,7 +271,6 @@ add_cache(tcpr_cache_t ** cachedata, const int send, const tcpr_dir_t interface)
         lastcache = *cachedata;
     }
     else {
-        lastcache = *cachedata;
         /* check to see if this is the last bit in this struct */
         if ((lastcache->packets + 1) > (CACHEDATASIZE * CACHE_PACKETS_PER_BYTE)) {
             /*
diff --git a/src/common/cidr.c b/src/common/cidr.c
index 223d569df..54a15d17b 100644
--- a/src/common/cidr.c
+++ b/src/common/cidr.c
@@ -241,7 +241,7 @@ cidr2cidr(char *cidr)
             if (octets[count] > 255)
                 goto error;
 
-            snprintf(tempoctet, sizeof(octets[count]), "%d", octets[count]);
+            snprintf(tempoctet, sizeof(octets[count]), "%u", octets[count]);
             strcat(networkip, tempoctet);
             /* we don't want a '.' at the end of the last octet */
             if (count < 3)
diff --git a/src/common/get.c b/src/common/get.c
index 80b6ea4a6..8407d8f0d 100644
--- a/src/common/get.c
+++ b/src/common/get.c
@@ -78,13 +78,8 @@ get_pcap_version(void)
 uint16_t
 get_l2protocol(const u_char *pktdata, const int datalen, const int datalink)
 {
-    eth_hdr_t *eth_hdr;
-    vlan_hdr_t *vlan_hdr;
-    hdlc_hdr_t *hdlc_hdr;
-    sll_hdr_t *sll_hdr;
     uint16_t ether_type;
     uint16_t eth_hdr_offset = 0;
-    struct tcpr_pppserial_hdr *ppp;
 
     if (!pktdata || !datalen) {
         errx(-1, "invalid l2 parameters: pktdata=0x%p len=%d",
@@ -111,10 +106,11 @@ get_l2protocol(const u_char *pktdata, const int datalen, const int datalink)
         } else {
             eth_hdr_offset = 4; /* no header extensions */
         }
-        /* fall through */
+        /* no break */
     case DLT_EN10MB:
         if (datalen >= (sizeof(eth_hdr_t) + eth_hdr_offset)) {
-            eth_hdr = (eth_hdr_t *)(pktdata + eth_hdr_offset);
+            vlan_hdr_t *vlan_hdr;
+            eth_hdr_t *eth_hdr = (eth_hdr_t *)(pktdata + eth_hdr_offset);
             ether_type = ntohs(eth_hdr->ether_type);
             switch (ether_type) {
             case ETHERTYPE_VLAN: /* 802.1q */
@@ -128,7 +124,7 @@ get_l2protocol(const u_char *pktdata, const int datalen, const int datalink)
 
     case DLT_PPP_SERIAL:
         if (datalen >= sizeof(struct tcpr_pppserial_hdr)) {
-            ppp = (struct tcpr_pppserial_hdr *)pktdata;
+            struct tcpr_pppserial_hdr *ppp = (struct tcpr_pppserial_hdr *)pktdata;
             if (ntohs(ppp->protocol) == 0x0021)
                 return htons(ETHERTYPE_IP);
             else
@@ -138,14 +134,14 @@ get_l2protocol(const u_char *pktdata, const int datalen, const int datalink)
 
     case DLT_C_HDLC:
         if (datalen >= sizeof(hdlc_hdr_t)) {
-            hdlc_hdr = (hdlc_hdr_t *)pktdata;
+            hdlc_hdr_t *hdlc_hdr = (hdlc_hdr_t *)pktdata;
             return hdlc_hdr->protocol;
         }
         break;
 
     case DLT_LINUX_SLL:
         if (datalen >= sizeof(sll_hdr_t)) {
-            sll_hdr = (sll_hdr_t *)pktdata;
+            sll_hdr_t *sll_hdr = (sll_hdr_t *)pktdata;
             return sll_hdr->sll_protocol;
         }
         break;
@@ -166,8 +162,6 @@ get_l2protocol(const u_char *pktdata, const int datalen, const int datalink)
 int
 get_l2len(const u_char *pktdata, const int datalen, const int datalink)
 {
-    uint16_t ether_type = 0;
-    vlan_hdr_t *vlan_hdr;
     int l2_len = 0;
 
     assert(pktdata);
@@ -180,13 +174,13 @@ get_l2len(const u_char *pktdata, const int datalen, const int datalink)
 
     case DLT_JUNIPER_ETHER:
         l2_len = 24;
-        /* fall through */
+        /* no break */
     case DLT_EN10MB:
         if (datalen >= sizeof(eth_hdr_t) + l2_len) {
-            ether_type = ntohs(((eth_hdr_t*)(pktdata + l2_len))->ether_type);
+            uint16_t ether_type = ntohs(((eth_hdr_t*)(pktdata + l2_len))->ether_type);
 
             while (ether_type == ETHERTYPE_VLAN) {
-                vlan_hdr = (vlan_hdr_t *)(pktdata + l2_len);
+                vlan_hdr_t *vlan_hdr = (vlan_hdr_t *)(pktdata + l2_len);
                 ether_type = ntohs(vlan_hdr->vlan_len);
                 l2_len += 4;
                 if (datalen < sizeof(vlan_hdr_t) + l2_len) {
diff --git a/src/common/interface.c b/src/common/interface.c
index 18ae521ce..1c88ee0a4 100644
--- a/src/common/interface.c
+++ b/src/common/interface.c
@@ -84,8 +84,8 @@ get_interface_list(void)
     int fd = -1;
     nmreq_t nmr;
 #endif
-#if defined HAVE_LIBPCAP_NETMAP || defined HAVE_NETMAP
-    u_int32_t netmap_version = -1;
+#ifdef HAVE_NETMAP
+    u_int32_t netmap_version;
 #endif
 
 #ifndef HAVE_WIN32
@@ -135,8 +135,6 @@ get_interface_list(void)
             strncpy(nmr.nr_name, pcap_if_ptr->name, sizeof(nmr.nr_name));
             nmr.nr_version = netmap_version;
             if (ioctl(fd, NIOCGINFO, &nmr) == 0) {
-                int x;
-
 #endif /* HAVE_NETMAP */
 #if defined HAVE_LIBPCAP_NETMAP || defined HAVE_NETMAP
                 list_ptr->next = (interface_list_t *)safe_malloc(sizeof(interface_list_t));
@@ -150,8 +148,11 @@ get_interface_list(void)
                 snprintf(list_ptr->name, sizeof(list_ptr->name), "netmap:%s", pcap_if_ptr->name);
                 sprintf(list_ptr->alias, "%%%d", i++);
                 list_ptr->flags = pcap_if_ptr->flags;
-
+#endif /* HAVE_LIBPCAP_NETMAP  || HAVE_NETMAP */
+#ifdef HAVE_NETMAP
                 if (netmap_version >= 10) {
+                    int x;
+
                     list_ptr->next = (interface_list_t *)safe_malloc(sizeof(interface_list_t));
                     list_ptr = list_ptr->next;
                     snprintf(list_ptr->name, sizeof(list_ptr->name), "netmap:%s!", pcap_if_ptr->name);
@@ -169,10 +170,6 @@ get_interface_list(void)
                     snprintf(list_ptr->name, sizeof(list_ptr->name), "netmap:%s^", pcap_if_ptr->name);
                     sprintf(list_ptr->alias, "%%%d", i++);
                     list_ptr->flags = pcap_if_ptr->flags;
-                }
-#endif /* HAVE_LIBPCAP_NETMAP  || HAVE_NETMAP */
-#ifdef HAVE_NETMAP
-                if (netmap_version >= 10) {
                     for (x = 0; x < nmr.nr_rx_rings; ++x) {
                         list_ptr->next = (interface_list_t *)safe_malloc(sizeof(interface_list_t));
                         list_ptr = list_ptr->next;
diff --git a/src/common/list.c b/src/common/list.c
index f2d62f9f3..467c7027b 100644
--- a/src/common/list.c
+++ b/src/common/list.c
@@ -1,5 +1,3 @@
-/* $Id$ */
-
 /*
  *   Copyright (c) 2001-2010 Aaron Turner <aturner at synfin dot net>
  *   Copyright (c) 2013-2018 Fred Klassen <tcpreplay at appneta dot com> - AppNeta
@@ -62,7 +60,6 @@ parse_list(tcpr_list_t ** listdata, char *ourstr)
     char *first, *second;
     int rcode;
     regex_t preg;
-    char ebuf[EBUF_SIZE];
     char regex[] = "^[0-9]+(-[0-9]+)?$";
     char *token = NULL;
     u_int i;
@@ -70,6 +67,7 @@ parse_list(tcpr_list_t ** listdata, char *ourstr)
 
     /* compile the regex first */
     if ((rcode = regcomp(&preg, regex, REG_EXTENDED | REG_NOSUB)) != 0) {
+        char ebuf[EBUF_SIZE];
         regerror(rcode, &preg, ebuf, sizeof(ebuf));
         errx(-1, "Unable to compile regex (%s): %s", regex, ebuf);
     }
@@ -147,6 +145,7 @@ parse_list(tcpr_list_t ** listdata, char *ourstr)
 
 /**
  * Checks to see if the given integer exists in the LIST.
+ * Return 1 if in the list, otherwise 0
  */
 tcpr_dir_t
 check_list(tcpr_list_t * list, COUNTER value)
@@ -157,28 +156,22 @@ check_list(tcpr_list_t * list, COUNTER value)
     do {
         if ((current->min != 0) && (current->max != 0)) {
             if ((value >= current->min) && (value <= current->max))
-                return TCPR_DIR_C2S;
-        }
-        else if (current->min == 0) {
+                return 1;
+        } else if (current->min == 0) {
             if (value <= current->max)
-                return TCPR_DIR_C2S;
-        }
-        else if (current->max == 0) {
+                return 1;
+        } else if (current->max == 0) {
             if (value >= current->min)
-                return TCPR_DIR_C2S;
+                return 1;
         }
 
-        if (current->next != NULL) {
+        if (current->next != NULL)
             current = current->next;
-        }
-        else {
+        else
             current = NULL;
-        }
-
     } while (current != NULL);
 
-    return TCPR_DIR_S2C;
-
+    return 0;
 }
 
 
diff --git a/src/common/sendpacket.c b/src/common/sendpacket.c
index ef490a4b6..1c344a928 100644
--- a/src/common/sendpacket.c
+++ b/src/common/sendpacket.c
@@ -486,7 +486,6 @@ sendpacket_open(const char *device, char *errbuf, tcpr_dir_t direction,
                   errx(-1, "\"%s\" is a block device and is not a valid Tcpreplay device",
                       device);
                   break;
-                  break;
               case S_IFDIR:
                   errx(-1, "\"%s\" is a directory and is not a valid Tcpreplay device",
                       device);
diff --git a/src/common/services.c b/src/common/services.c
index b35b0166d..fe2aed098 100644
--- a/src/common/services.c
+++ b/src/common/services.c
@@ -71,11 +71,6 @@ parse_services(const char *file, tcpr_services_t *services)
         /* look for format of 1234/tcp */
         if ((regexec(&preg, service_line, nmatch, pmatch, 0)) == 0) { /* matches */
             uint16_t portc;
-
-            if (nmatch < 2) {
-                err(-1, "WTF?  I matched the line, but I don't know where!");
-            }
-
             /* strip out the port & proto from the line */
             strncpy(port, &service_line[pmatch[1].rm_so], (pmatch[1].rm_eo - pmatch[1].rm_so));
             strncpy(proto, &service_line[pmatch[2].rm_so], (pmatch[2].rm_eo - pmatch[2].rm_so));
diff --git a/src/common/tcpdump.c b/src/common/tcpdump.c
index d72882260..d73634780 100644
--- a/src/common/tcpdump.c
+++ b/src/common/tcpdump.c
@@ -67,44 +67,81 @@ static int can_exec(const char *filename);
 int
 tcpdump_print(tcpdump_t *tcpdump, struct pcap_pkthdr *pkthdr, const u_char *data)
 {
-    struct pollfd poller[1];
-    int result;
+    struct pollfd poller;
+    int res, total;
     char decode[TCPDUMP_DECODE_LEN];
+    struct compact_pkthdr {
+        struct {
+            uint32_t ts_sec;
+            uint32_t ts_usec;
+        } ts;
+        uint32_t caplen;              /* length of portion present */
+        uint32_t len;                 /* length this packet (off wire) */
+    } actual_pkthdr;
 
     assert(tcpdump);
     assert(pkthdr);
     assert(data);
 
-    poller[0].fd = tcpdump->infd;
-    poller[0].events = POLLOUT;
-    poller[0].revents = 0;
-    
-    /* wait until we can write to the tcpdump socket */
-    result = poll(poller, 1, TCPDUMP_POLL_TIMEOUT);
-    if (result < 0)
-        errx(-1, "Error during poll() to write to tcpdump\n%s", strerror(errno));
-
-    if (result == 0)
+    /* convert header to file-format packet header */
+    actual_pkthdr.ts.ts_sec = (uint32_t)pkthdr->ts.tv_sec;
+    actual_pkthdr.ts.ts_usec = (uint32_t)pkthdr->ts.tv_sec;
+    actual_pkthdr.caplen = pkthdr->caplen;
+    actual_pkthdr.len = pkthdr->len;
+
+    total = 0;
+header_again:
+    poller.fd = PARENT_WRITE_FD;
+    poller.events = POLLOUT;
+    poller.revents = 0;
+
+    /* wait until we can write the header to the tcpdump pipe */
+    res = poll(&poller, 1, TCPDUMP_POLL_TIMEOUT);
+    if (res < 0)
+        errx(-1, "Error writing header to fd %d during poll() to write to tcpdump\n%s",
+                PARENT_WRITE_FD, strerror(errno));
+
+    if (res == 0)
         err(-1, "poll() timeout... tcpdump seems to be having a problem keeping up\n"
             "Try increasing TCPDUMP_POLL_TIMEOUT");
 
-
-    /* result > 0 if we get here */
-
-    if (write(tcpdump->infd, (char *)pkthdr, sizeof(struct pcap_pkthdr))
-        != sizeof(struct pcap_pkthdr))
-        errx(-1, "Error writing pcap file header to tcpdump\n%s", strerror(errno));
-
 #ifdef DEBUG
     if (debug >= 5) {
-        if (write(tcpdump->debugfd, (char *)pkthdr, sizeof(struct pcap_pkthdr))
-            != sizeof(struct pcap_pkthdr))
+        if (write(tcpdump->debugfd, (char *)&actual_pkthdr, sizeof(actual_pkthdr))
+            != sizeof(actual_pkthdr))
             errx(-1, "Error writing pcap file header to tcpdump debug\n%s", strerror(errno));
     }
 #endif
+    /* res > 0 if we get here */
+    while (total != sizeof(actual_pkthdr) &&
+            (res = write(PARENT_WRITE_FD, &actual_pkthdr + total,
+                    sizeof(actual_pkthdr) - total))) {
+        if (res < 0) {
+            if (errno == EAGAIN)
+                goto header_again;
+
+            errx(-1, "Error writing pcap file header to tcpdump\n%s",
+                    strerror(errno));
+        }
+
+        total += res;
+    }
+
+    total = 0;
+data_again:
+    /* wait until we can write data to the tcpdump pipe */
+    poller.fd = PARENT_WRITE_FD;
+    poller.events = POLLOUT;
+    poller.revents = 0;
 
-    if (write(tcpdump->infd, data, pkthdr->caplen) != (ssize_t)pkthdr->caplen)
-        errx(-1, "Error writing packet data to tcpdump\n%s", strerror(errno));
+    res = poll(&poller, 1, TCPDUMP_POLL_TIMEOUT);
+    if (res < 0)
+        errx(-1, "Error writing to fd %d during poll() to write to tcpdump\n%s",
+                PARENT_WRITE_FD, strerror(errno));
+
+    if (res == 0)
+        err(-1, "poll() timeout... tcpdump seems to be having a problem keeping up\n"
+            "Try increasing TCPDUMP_POLL_TIMEOUT");
 
 #ifdef DEBUG
     if (debug >= 5) {
@@ -113,27 +150,44 @@ tcpdump_print(tcpdump_t *tcpdump, struct pcap_pkthdr *pkthdr, const u_char *data
     }
 #endif
 
+    while (total != (ssize_t)pkthdr->caplen &&
+            (res = write(PARENT_WRITE_FD, data + total, pkthdr->caplen - total))) {
+        if (res < 0) {
+            if (errno == EAGAIN)
+                goto data_again;
+
+            errx(-1, "Error writing packet data to tcpdump\n%s", strerror(errno));
+        }
+
+        total += res;
+    }
+
     /* Wait for output from tcpdump */
-    poller[0].fd = tcpdump->outfd;
-    poller[0].events = POLLIN;
-    poller[0].revents = 0;
+    poller.fd = PARENT_READ_FD;
+    poller.events = POLLIN;
+    poller.revents = 0;
 
-    result = poll(poller, 1, TCPDUMP_POLL_TIMEOUT);
-    if (result < 0)
-        errx(-1, "Error during poll() to write to tcpdump\n%s", strerror(errno));
+    res = poll(&poller, 1, TCPDUMP_POLL_TIMEOUT);
+    if (res < 0)
+        errx(-1, "Error out to fd %d during poll() to read frome tcpdump\n%s",
+                PARENT_READ_FD, strerror(errno));
 
-    if (result == 0)
+    if (res == 0)
         err(-1, "poll() timeout... tcpdump seems to be having a problem keeping up\n"
             "Try increasing TCPDUMP_POLL_TIMEOUT");
 
-    result = read(tcpdump->outfd, &decode, TCPDUMP_DECODE_LEN);
-    if (result < 0)
-        errx(-1, "Error reading tcpdump decode: %s", strerror(errno));
+    while ((res = read(PARENT_READ_FD, decode, TCPDUMP_DECODE_LEN))) {
+        if (res < 0) {
+            if (errno == EAGAIN)
+                break;
 
-    /* result > 0 if we get here */
-    decode[min(result, TCPDUMP_DECODE_LEN)] = 0;
+            errx(-1, "Error reading tcpdump decode: %s", strerror(errno));
+        }
 
-    printf("%s", decode);
+        decode[min(res, TCPDUMP_DECODE_LEN-1)] = 0;
+        dbgx(4, "read %d byte from tcpdump", res);
+        printf("%s", decode);
+    }
 
     return TRUE;
 }
@@ -146,9 +200,6 @@ tcpdump_print(tcpdump_t *tcpdump, struct pcap_pkthdr *pkthdr, const u_char *data
 int
 tcpdump_open(tcpdump_t *tcpdump, pcap_t *pcap)
 {
-    int infd[2], outfd[2];
-    FILE *writer;
-
     assert(tcpdump);
     assert(pcap);
 
@@ -180,13 +231,10 @@ tcpdump_open(tcpdump_t *tcpdump, pcap_t *pcap)
 
     dbg(2, "Starting tcpdump...");
 
-    /* create our socket pair to send packet data to tcpdump via */
-    if (socketpair(AF_UNIX, SOCK_STREAM, 0, infd) < 0)
-        errx(-1, "Unable to create stdin socket pair: %s", strerror(errno));
-
-    /* create our socket pair to read packet decode from tcpdump */
-    if (socketpair(AF_UNIX, SOCK_STREAM, 0, outfd) < 0)
-        errx(-1, "Unable to create stdout socket pair: %s", strerror(errno));
+    /* create our pipe to send packet data to tcpdump via */
+    if (pipe(tcpdump->pipes[PARENT_READ_PIPE]) < 0 ||
+            pipe(tcpdump->pipes[PARENT_WRITE_PIPE]) < 0)
+        errx(-1, "Unable to create pipe: %s", strerror(errno));
 
     if ((tcpdump->pid = fork() ) < 0)
         errx(-1, "Fork failed: %s", strerror(errno));
@@ -194,57 +242,61 @@ tcpdump_open(tcpdump_t *tcpdump, pcap_t *pcap)
     dbgx(2, "tcpdump pid: %d", tcpdump->pid);
 
     if (tcpdump->pid > 0) {
-        /* we're still in tcpreplay */
-        dbgx(2, "[parent] closing input fd %d", infd[1]);
-        close(infd[1]);  /* close the tcpdump side */
-        dbgx(2, "[parent] closing output fd %d", outfd[1]);
-        close(outfd[1]);
-        tcpdump->infd = infd[0];
-        tcpdump->outfd = outfd[0];
+        /* parent - we're still in tcpreplay */
+
+        /* close fds not required by parent */
+        dbgx(2, "[parent] closing child read/write fd %d/%d", CHILD_READ_FD,
+                CHILD_WRITE_FD);
+        close(CHILD_READ_FD);
+        close(CHILD_WRITE_FD);
+        CHILD_READ_FD = 0;
+        CHILD_WRITE_FD = 0;
 
         /* send the pcap file header to tcpdump */
-        writer = fdopen(tcpdump->infd, "w");
-        if ((tcpdump->dumper = pcap_dump_fopen(pcap, writer)) == NULL) {
+        FILE *writer = fdopen(PARENT_WRITE_FD, "w");
+        if ((pcap_dump_fopen(pcap, writer)) == NULL) {
             warnx("[parent] pcap_dump_fopen(): %s", pcap_geterr(pcap));
             return FALSE;
         }
-        pcap_dump_flush(tcpdump->dumper);
 
-        if (fcntl(tcpdump->infd, F_SETFL, O_NONBLOCK) < 0)
-            warnx("[parent] Unable to fcntl tcpreplay socket:\n%s", strerror(errno));
+        pcap_dump_flush((pcap_dumper_t*)writer);
 
-        if (fcntl(tcpdump->outfd, F_SETFL, O_NONBLOCK) < 0)
-            warnx("[parent] Unable to fnctl stdout socket:\n%s", strerror(errno));
+        if (fcntl(PARENT_WRITE_FD, F_SETFL, O_NONBLOCK) < 0)
+            warnx("[parent] Unable to fcntl write pipe:\n%s", strerror(errno));
 
-    }
-    else {
+        if (fcntl(PARENT_READ_FD, F_SETFL, O_NONBLOCK) < 0)
+            warnx("[parent] Unable to fnctl read pip:\n%s", strerror(errno));
+    } else {
         dbg(2, "[child] started the kid");
 
-        /* we're in the child process */
-        dbgx(2, "[child] closing in fd %d", infd[0]);
-        dbgx(2, "[child] closing out fd %d", outfd[0]);
-        close(infd[0]); /* close the tcpreplay side */
-        close(outfd[0]);
-
-        /* copy our side of the socketpair to our stdin */
-        if (infd[1] != STDIN_FILENO) {
-            if (dup2(infd[1], STDIN_FILENO) != STDIN_FILENO)
-                errx(-1, "[child] Unable to copy socket to stdin: %s", 
-                    strerror(errno));
+        /* we're in the child process - run "tcpdump  <options> -r -" */
+        if (dup2(CHILD_READ_FD, STDIN_FILENO) != STDIN_FILENO) {
+            errx(-1, "[child] Unable to duplicate socket to stdin: %s",
+                                strerror(errno));
         }
 
-        /* copy our side of the socketpair to our stdout */
-        if (outfd[1] != STDOUT_FILENO) {
-            if (dup2(outfd[1], STDOUT_FILENO) != STDOUT_FILENO)
-                errx(-1, "[child] Unable to copy socket to stdout: %s", 
-                    strerror(errno));
+        if (dup2(CHILD_WRITE_FD, STDOUT_FILENO) != STDOUT_FILENO) {
+            errx(-1, "[child] Unable to duplicate socket to stdout: %s",
+                                strerror(errno));
         }
 
+        /*
+         * Close sockets not required by child. The exec'ed program must
+         * not know that they ever existed.
+         */
+        dbgx(2, "[child] closing in fds %d/%d/%d/%d", CHILD_READ_FD,
+                CHILD_WRITE_FD, PARENT_READ_FD, PARENT_WRITE_FD);
+        close(CHILD_READ_FD);
+        close(CHILD_WRITE_FD);
+        close(PARENT_READ_FD);
+        close(PARENT_WRITE_FD);
+
         /* exec tcpdump */
         dbg(2, "[child] Exec'ing tcpdump...");
         if (execv(TCPDUMP_BINARY, options_vec) < 0)
             errx(-1, "Unable to exec tcpdump: %s", strerror(errno));
 
+        dbg(2, "[child] tcpdump done!");
     }
 
     return TRUE;
@@ -265,15 +317,15 @@ tcpdump_close(tcpdump_t *tcpdump)
     dbgx(2, "[parent] killing tcpdump pid: %d", tcpdump->pid);
 
     kill(tcpdump->pid, SIGKILL);
-    close(tcpdump->infd);
-    close(tcpdump->outfd);
+    close(PARENT_READ_FD);
+    close(PARENT_WRITE_FD);
 
     if (waitpid(tcpdump->pid, NULL, 0) != tcpdump->pid)
         errx(-1, "[parent] Error in waitpid: %s", strerror(errno));
 
     tcpdump->pid = 0;
-    tcpdump->infd = 0;
-    tcpdump->outfd = 0;
+    PARENT_READ_FD = 0;
+    PARENT_WRITE_FD = 0;
 }
 
 /** 
@@ -283,12 +335,10 @@ void
 tcpdump_kill(tcpdump_t *tcpdump)
 {
     if (tcpdump->pid) {
-        if (kill(tcpdump->pid, SIGTERM) != 0) {
+        if (kill(tcpdump->pid, SIGTERM) != 0)
             kill(tcpdump->pid, SIGKILL);
-        }
     }
-    tcpdump->infd = 0;
-    tcpdump->outfd = 0;
+
     tcpdump->pid = 0;
 }
 
@@ -333,10 +383,10 @@ tcpdump_fill_in_options(char *opt)
     options_vec[i++] = newarg;
 
     /* process the remaining args 
-       note that i < OPTIONS_VEC_SIZE - 1
-       because: a) we need to add '-' as an option to the end
-       b) because the array has to be null terminated
-    */
+     * note that i < OPTIONS_VEC_SIZE - 1
+     * because: a) we need to add '-' as an option to the end
+     * b) because the array has to be null terminated
+     */
     while (((arg = strtok_r(NULL, OPT_DELIM, &token)) != NULL) &&
            (i < OPTIONS_VEC_SIZE - 1)) {
 
@@ -351,7 +401,7 @@ tcpdump_fill_in_options(char *opt)
     /* tell -r to read from stdin */
     options_vec[i] = "-";
 
-    return(i);
+    return i;
 }
 
 
diff --git a/src/common/tcpdump.h b/src/common/tcpdump.h
index 5d595cbda..7b9238bd6 100644
--- a/src/common/tcpdump.h
+++ b/src/common/tcpdump.h
@@ -42,14 +42,45 @@
 
 #define TCPDUMP_DECODE_LEN 65535
 
+/*
+ * fork a copy of tcpdump so we can parse packets and print to the screen. We
+ * don't allow tcpdump to write directly to the screen, otherwise there
+ * will be a garbled up mess. Instead we pipe it back to this program and
+ * print when we are ready to do so.
+ *
+ * parent: this program
+ * child: tcpdump
+ *
+ * pipes are unidirectional, so we need to set up 2 pipes:
+ *
+ * 1. data from parent to child's STDIN
+ * 2. child's STDOUT to this program
+ */
+#define NUM_PIPES   2
+
+/* unidirectional rule for pipes: pipe[0] for read, pipe[1] for writes  */
+enum {
+    READ_FD,
+    WRITE_FD,
+};
+
+enum {
+    PARENT_READ_PIPE,
+    PARENT_WRITE_PIPE,
+};
+
+#define PARENT_READ_FD  (tcpdump->pipes[PARENT_READ_PIPE][READ_FD])
+#define PARENT_WRITE_FD (tcpdump->pipes[PARENT_WRITE_PIPE][WRITE_FD])
+
+#define CHILD_READ_FD   (tcpdump->pipes[PARENT_WRITE_PIPE][READ_FD])
+#define CHILD_WRITE_FD  (tcpdump->pipes[PARENT_READ_PIPE][WRITE_FD])
+
 typedef struct tcpdump_s {
     char *filename;
     char *args;
     struct pcap_file_header pfh;
     int pid;
-    int infd; /* fd to write to. 1/2 of the socketpair */
-    int outfd; /* fd to read from. */
-    pcap_dumper_t *dumper;
+    int pipes[NUM_PIPES][2];
 
     /* following vars are for figuring out exactly what we send to
      * tcpdump.  See TCPDUMP_DEBUG 
diff --git a/src/common/utils.c b/src/common/utils.c
index a280e2a61..4e56891f6 100644
--- a/src/common/utils.c
+++ b/src/common/utils.c
@@ -28,6 +28,10 @@
 #include <ctype.h>
 #include <unistd.h>
 
+#ifdef HAVE_SYS_IOCTL_H
+#include <sys/ioctl.h>
+#endif
+
 #ifdef DEBUG
 extern int debug;
 #endif
@@ -44,7 +48,8 @@ _our_safe_malloc(size_t len, const char *funcname, const int line, const char *f
     u_char *ptr;
 
     if ((ptr = malloc(len)) == NULL) {
-        fprintf(stderr, "ERROR in %s:%s() line %d: Unable to malloc() %zu bytes", file, funcname, line, len);
+        fprintf(stderr, "ERROR in %s:%s() line %d: Unable to malloc() %zu bytes/n",
+                file, funcname, line, len);
         exit(-1);
     }
 
@@ -115,6 +120,57 @@ _our_safe_free(void *ptr, const char *funcname, const int line, const char *file
     ptr = NULL;
 }
 
+/**
+ * get next packet in pcap file
+ */
+u_char *_our_safe_pcap_next(pcap_t *pcap,  struct pcap_pkthdr *pkthdr,
+        const char *funcname, const int line, const char *file)
+{
+    u_char *pktdata = (u_char *)pcap_next(pcap, pkthdr);
+
+    if (pktdata) {
+        if (pkthdr->len > MAXPACKET) {
+            fprintf(stderr, "safe_pcap_next ERROR: Invalid packet length in %s:%s() line %d: %u is greater than maximum %u\n",
+                    file, funcname, line, pkthdr->len, MAXPACKET);
+            exit(-1);
+        }
+
+        if (pkthdr->len < pkthdr->caplen) {
+            fprintf(stderr, "safe_pcap_next ERROR: Invalid packet length in %s:%s() line %d: packet length %u is less than capture length %u\n",
+                    file, funcname, line, pkthdr->len, pkthdr->caplen);
+            exit(-1);
+        }
+    }
+
+    return pktdata;
+}
+
+/**
+ * get next packet in pcap file (extended)
+ */
+int _our_safe_pcap_next_ex(pcap_t *pcap, struct pcap_pkthdr **pkthdr,
+        const u_char **pktdata, const char *funcname,
+        const int line, const char *file)
+{
+    int res = pcap_next_ex(pcap, pkthdr, pktdata);
+
+    if (*pktdata && *pkthdr) {
+        if ((*pkthdr)->len > MAXPACKET) {
+            fprintf(stderr, "safe_pcap_next_ex ERROR: Invalid packet length in %s:%s() line %d: %u is greater than maximum %u\n",
+                    file, funcname, line, (*pkthdr)->len, MAXPACKET);
+            exit(-1);
+        }
+
+        if ((*pkthdr)->len < (*pkthdr)->caplen) {
+            fprintf(stderr, "safe_pcap_next_ex ERROR: Invalid packet length in %s:%s() line %d: packet length %u is less than capture length %u\n",
+                    file, funcname, line, (*pkthdr)->len, (*pkthdr)->caplen);
+            exit(-1);
+        }
+    }
+
+    return res;
+}
+
 /**
  * Print various packet statistics
  */
@@ -335,3 +391,19 @@ int tcpr_random(uint32_t *seed)
 
   return result;
 }
+
+/**
+ * #416 - Ensure STDIN is not left in non-blocking mode after closing
+ * a program. BSD and Unix derivatives should utilize `FIONBIO` due to known
+ * issues with reading from tty with a 0 byte read returning -1 opposed to 0.
+ */
+void restore_stdin(void)
+{
+#ifdef FIONBIO
+    int nb = 0;
+
+    ioctl(0, FIONBIO, &nb);
+#else
+    fcntl(0, F_SETFL, fcntl(0, F_GETFL) | O_NONBLOCK);
+#endif /* FIONBIO */
+}
diff --git a/src/common/utils.h b/src/common/utils.h
index e9c6828bf..98c317508 100644
--- a/src/common/utils.h
+++ b/src/common/utils.h
@@ -48,6 +48,7 @@ int read_hexstring(const char *l2string, u_char *hex, const int hexlen);
 void packet_stats(const tcpreplay_stats_t *stats);
 int format_date_time(struct timeval *when, char *buf, size_t len);
 int tcpr_random(uint32_t *seed);
+void restore_stdin(void);
 
 /* our "safe" implimentations of functions which allocate memory */
 #define safe_malloc(x) _our_safe_malloc(x, __FUNCTION__, __LINE__, __FILE__)
@@ -62,6 +63,15 @@ char *_our_safe_strdup(const char *str, const char *, const int, const char *);
 #define safe_free(x) _our_safe_free(x, __FUNCTION__, __LINE__, __FILE__)
 void _our_safe_free(void *ptr, const char *, const int, const char *);
 
+#define safe_pcap_next(x, y) _our_safe_pcap_next(x, y, __FUNCTION__, __LINE__, __FILE__)
+u_char *_our_safe_pcap_next(pcap_t *pcap,  struct pcap_pkthdr *pkthdr,
+        const char *funcname, const int line, const char *file);
+
+#define safe_pcap_next_ex(x, y, z) _our_safe_pcap_next_ex(x, y, z, __FUNCTION__, __LINE__, __FILE__)
+int _our_safe_pcap_next_ex(pcap_t *pcap, struct pcap_pkthdr **pkthdr,
+        const u_char **pktdata, const char *funcname,
+        const int line, const char *file);
+
 #define MAX_ARGS 128
 
 #ifndef HAVE_INET_ATON
diff --git a/src/config.h.in b/src/config.h.in
index a815a4551..d5277e415 100644
--- a/src/config.h.in
+++ b/src/config.h.in
@@ -278,9 +278,6 @@
 /* Define to 1 if you have the <net/bpf.h> header file. */
 #undef HAVE_NET_BPF_H
 
-/* Define to 1 if you have the <net/netmap_user.h> header file. */
-#undef HAVE_NET_NETMAP_USER_H
-
 /* Define to 1 if you have the <net/route.h> header file. */
 #undef HAVE_NET_ROUTE_H
 
@@ -390,9 +387,6 @@
 /* Define to 1 if you have the <stdint.h> header file. */
 #undef HAVE_STDINT_H
 
-/* Define to 1 if you have the <stdio.h> header file. */
-#undef HAVE_STDIO_H
-
 /* Define to 1 if you have the <stdlib.h> header file. */
 #undef HAVE_STDLIB_H
 
@@ -600,8 +594,7 @@
    slash. */
 #undef LSTAT_FOLLOWS_SLASHED_SYMLINK
 
-/* Define to the sub-directory in which libtool stores uninstalled libraries.
-   */
+/* Define to the sub-directory where libtool stores uninstalled libraries. */
 #undef LT_OBJDIR
 
 /* Define to 1 if `major', `minor', and `makedev' are declared in <mkdev.h>.
diff --git a/src/fragroute/bget.c b/src/fragroute/bget.c
index f2190f275..a03037975 100644
--- a/src/fragroute/bget.c
+++ b/src/fragroute/bget.c
@@ -811,11 +811,11 @@ void brel(buf)
 {
     struct bfhead *b, *bn;
 
+    assert(buf != NULL);
     b = BFH(((char *) buf) - sizeof(struct bhead));
 #ifdef BufStats
     numrel++;			      /* Increment number of brel() calls */
 #endif
-    assert(buf != NULL);
 
 #ifdef BECtl
     if (b->bh.bsize == 0) {	      /* Directly-acquired buffer? */
diff --git a/src/fragroute/fragroute.c b/src/fragroute/fragroute.c
index 336fd64ee..1481742ff 100644
--- a/src/fragroute/fragroute.c
+++ b/src/fragroute/fragroute.c
@@ -42,7 +42,6 @@ fragroute_close(fragroute_t *ctx)
     assert(ctx);
     free(ctx->pktq);
     free(ctx);
-    ctx = NULL;
     pkt_close();
 }
 
diff --git a/src/fragroute/mod_ip6_opt.c b/src/fragroute/mod_ip6_opt.c
index 7efbbcb9d..46b5b6c44 100644
--- a/src/fragroute/mod_ip6_opt.c
+++ b/src/fragroute/mod_ip6_opt.c
@@ -56,7 +56,6 @@ void *
 ip6_opt_open(int argc, char *argv[])
 {
 	struct ip6_opt_data *opt;
-	int i, j;
 
 	if (argc < 4)
 		return (NULL);
@@ -65,8 +64,9 @@ ip6_opt_open(int argc, char *argv[])
 		return (NULL);
 
 	if (strcasecmp(argv[1], "route") == 0) {
-		opt->type = OPT6_TYPE_ROUTE;
+	    int i, j;
 
+	    opt->type = OPT6_TYPE_ROUTE;
 		if ((opt->u.route.segments = atoi(argv[2])) < 1 ||
 				opt->u.route.segments > MAX_ADDRS) {
 			warnx("<segments> must be >= 1");
diff --git a/src/fragroute/mod_ip6_qos.c b/src/fragroute/mod_ip6_qos.c
index f2439b4e6..e3ffcc2e3 100644
--- a/src/fragroute/mod_ip6_qos.c
+++ b/src/fragroute/mod_ip6_qos.c
@@ -41,11 +41,11 @@ ip6_qos_open(int argc, char *argv[])
 	if ((data = calloc(1, sizeof(*data))) == NULL)
 		return (NULL);
 
-	if (sscanf(argv[1], "%x", &data->ip6_tc) != 1 ||
+	if (sscanf(argv[1], "%x", (unsigned int*)&data->ip6_tc) != 1 ||
 			data->ip6_tc < 0 || data->ip6_tc > 255)
 		return (ip6_qos_close(data));
 
-	if (sscanf(argv[2], "%x", &data->ip6_fl) != 1 ||
+	if (sscanf(argv[2], "%x", (unsigned int*)&data->ip6_fl) != 1 ||
 			data->ip6_fl < 0 || data->ip6_fl > 0x100000)
 		return (ip6_qos_close(data));
 
diff --git a/src/replay.c b/src/replay.c
index 7457d3298..018c6be92 100644
--- a/src/replay.c
+++ b/src/replay.c
@@ -154,17 +154,12 @@ replay_file(tcpreplay_t *ctx, int idx)
         }
     }
 
-#if 0
-/*
- * this API is broken right now.  This needs to be handled via a pipe or 
- * something else so we can pass the output up to the calling programm 
- */
 #ifdef ENABLE_VERBOSE
     if (ctx->options->verbose) {
         /* in cache mode, we may not have opened the file */
         if (pcap == NULL)
             if ((pcap = pcap_open_offline(path, ebuf)) == NULL) {
-               tcpreplay_seterr("Error opening pcap file: %s", ebuf);
+               tcpreplay_seterr(ctx, "Error opening pcap file: %s", ebuf);
                return -1;
             }
 
@@ -172,7 +167,6 @@ replay_file(tcpreplay_t *ctx, int idx)
         /* init tcpdump */
         tcpdump_open(ctx->options->tcpdump, pcap);
     }
-#endif
 #endif
 
     if (pcap != NULL) {
@@ -196,10 +190,8 @@ replay_file(tcpreplay_t *ctx, int idx)
     if (pcap != NULL)
         pcap_close(pcap);
 
-#if 0
 #ifdef ENABLE_VERBOSE
     tcpdump_close(ctx->options->tcpdump);
-#endif
 #endif
     return 0;
 }
diff --git a/src/send_packets.c b/src/send_packets.c
index 6a3a7b4a5..fa1f39666 100644
--- a/src/send_packets.c
+++ b/src/send_packets.c
@@ -1021,7 +1021,7 @@ get_next_packet(tcpreplay_t *ctx, pcap_t *pcap, struct pcap_pkthdr *pkthdr, int
             /*
              * We should read the pcap file, and cache the results
              */
-            pktdata = (u_char *)pcap_next(pcap, pkthdr);
+            pktdata = safe_pcap_next(pcap, pkthdr);
             if (pktdata != NULL) {
                 if (*prev_packet == NULL) {
                     /*
@@ -1051,7 +1051,7 @@ get_next_packet(tcpreplay_t *ctx, pcap_t *pcap, struct pcap_pkthdr *pkthdr, int
         /*
          * Read pcap file as normal
          */
-        pktdata = (u_char *)pcap_next(pcap, pkthdr);
+        pktdata = safe_pcap_next(pcap, pkthdr);
     }
 
     /* this get's casted to a const on the way out */
@@ -1146,7 +1146,7 @@ static bool calc_sleep_time(tcpreplay_t *ctx, struct timeval *pkt_time_delta,
                 dbgx(3, "original packet delta pkt_time: " TIMEVAL_FORMAT, nap_for.tv_sec, nap_for.tv_usec);
 
                 TIMEVAL_TO_TIMESPEC(&nap_for, &ctx->nap);
-                dbgx(3, "original packet delta timv: " TIMESPEC_FORMAT, ctx->nap.tv_sec, ctx->nap.tv_nsec);
+                dbgx(3, "original packet delta time: " TIMESPEC_FORMAT, ctx->nap.tv_sec, ctx->nap.tv_nsec);
                 timesdiv_float(&ctx->nap, options->speed.multiplier);
                 dbgx(3, "original packet delta/div: " TIMESPEC_FORMAT, ctx->nap.tv_sec, ctx->nap.tv_nsec);
             } else {
diff --git a/src/tcpbridge.c b/src/tcpbridge.c
index 7d1de8129..41ada589e 100644
--- a/src/tcpbridge.c
+++ b/src/tcpbridge.c
@@ -114,6 +114,7 @@ main(int argc, char *argv[])
     tcpdump_close(options.tcpdump);
 #endif
 
+    restore_stdin();
     return 0;
 }
 
diff --git a/src/tcpcapinfo.c b/src/tcpcapinfo.c
index 8cb08a2a9..86ba4d56e 100644
--- a/src/tcpcapinfo.c
+++ b/src/tcpcapinfo.c
@@ -332,13 +332,11 @@ main(int argc, char *argv[])
             } else if (backwards && caplentoobig) {
                 printf("BAD_TS|TOOBIG");
             } 
-
         }
-
     }
 
-    exit(0);
-
+    restore_stdin();
+    return 0;
 }
 
 /**
diff --git a/src/tcpedit/edit_packet.c b/src/tcpedit/edit_packet.c
index ad7cc09de..ea185ac51 100644
--- a/src/tcpedit/edit_packet.c
+++ b/src/tcpedit/edit_packet.c
@@ -91,7 +91,7 @@ fix_ipv4_checksums(tcpedit_t *tcpedit, struct pcap_pkthdr *pkthdr, ipv4_hdr_t *i
 }
 
 /**
- * Returns ipv6 header length wth all ipv6 options on success
+ * Returns ipv6 header length with all ipv6 options on success
  *         -1 on error
  */
 static int
@@ -146,6 +146,21 @@ fix_ipv6_checksums(tcpedit_t *tcpedit, struct pcap_pkthdr *pkthdr, ipv6_hdr_t *i
     return TCPEDIT_OK;
 }
 
+/*
+ * #406 fix IP headers which may be not be set properly due to TCP segmentation
+ */
+void fix_ipv4_length(struct pcap_pkthdr *pkthdr, ipv4_hdr_t *ip_hdr)
+{
+    if (!ip_hdr->ip_len)
+        ip_hdr->ip_len = pkthdr->len;
+}
+
+void fix_ipv6_length(struct pcap_pkthdr *pkthdr, ipv6_hdr_t *ip6_hdr)
+{
+    if (!ip6_hdr->ip_len)
+        ip6_hdr->ip_len = pkthdr->len;
+}
+
 static void ipv4_l34_csum_replace(uint8_t *data, uint8_t protocol,
         uint32_t old, uint32_t new)
 {
@@ -507,10 +522,9 @@ extract_data(tcpedit_t *tcpedit, const u_char *pktdata, int caplen,
         char *l7data[])
 {
     int datalen = 0; /* amount of data beyond ip header */
-    ipv4_hdr_t *ip_hdr = NULL;
-    tcp_hdr_t *tcp_hdr = NULL;
+    ipv4_hdr_t *ip_hdr;
     u_char ipbuff[MAXPACKET];
-    u_char *dataptr = NULL;
+    u_char *dataptr;
     int ip_len;
     
     assert(tcpedit);
@@ -542,7 +556,7 @@ extract_data(tcpedit_t *tcpedit, const u_char *pktdata, int caplen,
 
     /* TCP ? */
     if (ip_hdr->ip_p == IPPROTO_TCP) {
-        tcp_hdr = (tcp_hdr_t *) get_layer4_v4(ip_hdr, datalen);
+        tcp_hdr_t *tcp_hdr = (tcp_hdr_t *) get_layer4_v4(ip_hdr, datalen);
         datalen -= tcp_hdr->th_off << 2;
         if (datalen <= 0)
             goto nodata;
@@ -949,7 +963,6 @@ randomize_iparp(tcpedit_t *tcpedit, struct pcap_pkthdr *pkthdr,
     arp_hdr_t *arp_hdr = NULL;
     int l2len = 0;
     uint32_t *ip;
-    u_char *add_hdr;
 #ifdef FORCE_ALIGN
     uint32_t iptemp;
 #endif
@@ -969,8 +982,8 @@ randomize_iparp(tcpedit_t *tcpedit, struct pcap_pkthdr *pkthdr,
          (ntohs(arp_hdr->ar_op) == ARPOP_REPLY))) {
 
         /* jump to the addresses */
-        add_hdr = (u_char *)arp_hdr;
-        add_hdr += sizeof(arp_hdr_t) + arp_hdr->ar_hln;
+        u_char *add_hdr = ((u_char *)arp_hdr) + sizeof(arp_hdr_t) +
+                arp_hdr->ar_hln;
 #ifdef FORCE_ALIGN
         /* copy IP to a temporary buffer for processing */
         memcpy(&iptemp, add_hdr, sizeof(uint32_t));
diff --git a/src/tcpedit/edit_packet.h b/src/tcpedit/edit_packet.h
index 769db7e69..3d086685a 100644
--- a/src/tcpedit/edit_packet.h
+++ b/src/tcpedit/edit_packet.h
@@ -42,6 +42,10 @@ int fix_ipv4_checksums(tcpedit_t *tcpedit, struct pcap_pkthdr *pkdhdr,
 int fix_ipv6_checksums(tcpedit_t *tcpedit, struct pcap_pkthdr *pkdhdr,
         ipv6_hdr_t *ip_hdr);
 
+void fix_ipv4_length(struct pcap_pkthdr *pkthdr, ipv4_hdr_t *ip_hdr);
+
+void fix_ipv6_length(struct pcap_pkthdr *pkthdr, ipv6_hdr_t *ip6_hdr);
+
 int extract_data(tcpedit_t *tcpedit, const u_char *pktdata, 
         int caplen, char *l7data[]);
 
diff --git a/src/tcpedit/plugins/dlt_en10mb/en10mb.c b/src/tcpedit/plugins/dlt_en10mb/en10mb.c
index a8ba2be52..6880727f9 100644
--- a/src/tcpedit/plugins/dlt_en10mb/en10mb.c
+++ b/src/tcpedit/plugins/dlt_en10mb/en10mb.c
@@ -104,8 +104,10 @@ dlt_en10mb_init(tcpeditdlt_t *ctx)
         return TCPEDIT_ERROR;
     }
     
-    ctx->decoded_extra = safe_malloc(sizeof(en10mb_extra_t));
-    plugin->config = safe_malloc(sizeof(en10mb_config_t));
+    ctx->decoded_extra_size = sizeof(en10mb_extra_t);
+    ctx->decoded_extra = safe_malloc(ctx->decoded_extra_size);
+    plugin->config_size = sizeof(en10mb_config_t);
+    plugin->config = safe_malloc(plugin->config_size);
     config = (en10mb_config_t *)plugin->config;
     
     /* init vlan user values to -1 to indicate not set */
@@ -135,11 +137,13 @@ dlt_en10mb_cleanup(tcpeditdlt_t *ctx)
     if (ctx->decoded_extra != NULL) {
         safe_free(ctx->decoded_extra);
         ctx->decoded_extra = NULL;
+        ctx->decoded_extra_size = 0;
     }
 
     if (plugin->config != NULL) {
         safe_free(plugin->config);
         plugin->config = NULL;
+        plugin->config_size = 0;
     }
         
     return TCPEDIT_OK; /* success */
@@ -222,7 +226,12 @@ dlt_en10mb_parse_opts(tcpeditdlt_t *ctx)
     assert(ctx);
 
     plugin = tcpedit_dlt_getplugin(ctx, dlt_value);
+    if (!plugin)
+        return TCPEDIT_ERROR;
+
     config = (en10mb_config_t *)plugin->config;
+    if (plugin->config_size < sizeof(*config))
+        return TCPEDIT_ERROR;
 
     /* --subsmacs */
     if (HAVE_OPT(ENET_SUBSMAC)) {
@@ -381,6 +390,9 @@ dlt_en10mb_decode(tcpeditdlt_t *ctx, const u_char *packet, const int pktlen)
     memcpy(&(ctx->srcaddr.ethernet), &(eth->ether_shost), ETHER_ADDR_LEN);
 
     extra = (en10mb_extra_t *)ctx->decoded_extra;
+    if (ctx->decoded_extra_size < sizeof(*extra))
+        return TCPEDIT_ERROR;
+
     extra->vlan = 0;
     
     /* get the L3 protocol type  & L2 len*/
@@ -436,9 +448,17 @@ dlt_en10mb_encode(tcpeditdlt_t *ctx, u_char *packet, int pktlen, tcpr_dir_t dir)
     }
 
     plugin = tcpedit_dlt_getplugin(ctx, dlt_value);
+    if (!plugin)
+        return TCPEDIT_ERROR;
+
     config = plugin->config;
+    if (plugin->config_size < sizeof(*config))
+        return TCPEDIT_ERROR;
+
     extra = (en10mb_extra_t *)ctx->decoded_extra;
-    
+    if (ctx->decoded_extra_size < sizeof(*extra))
+        return TCPEDIT_ERROR;
+
     /* figure out the new layer2 length, first for the case: ethernet -> ethernet? */
     if (ctx->decoder->dlt == dlt_value) {
         if ((ctx->l2len == TCPR_802_1Q_H && config->vlan == TCPEDIT_VLAN_OFF) ||
@@ -463,9 +483,21 @@ dlt_en10mb_encode(tcpeditdlt_t *ctx, u_char *packet, int pktlen, tcpr_dir_t dir)
         return TCPEDIT_ERROR;
     }
 
+    if (pktlen < ctx->l2len) {
+        tcpedit_seterr(ctx->tcpedit,
+                "Unable to process packet #" COUNTER_SPEC " since its new length less then %d L2 bytes.",
+                ctx->tcpedit->runtime.packetnum, ctx->l2len);
+        return TCPEDIT_ERROR;
+    }
+
     /* Make space for our new L2 header */
-    if (newl2len != ctx->l2len)
+    if (newl2len != ctx->l2len) {
+        if (pktlen + (newl2len - ctx->l2len) > MAXPACKET)
+            errx(-1, "New frame too big, new length %d exceeds %d",
+                    pktlen + (newl2len - ctx->l2len), MAXPACKET);
+
         memmove(packet + newl2len, packet + ctx->l2len, pktlen - ctx->l2len);
+    }
 
     /* update the total packet length */
     pktlen += newl2len - ctx->l2len;
diff --git a/src/tcpedit/plugins/dlt_hdlc/hdlc.c b/src/tcpedit/plugins/dlt_hdlc/hdlc.c
index fa919755e..90942d25d 100644
--- a/src/tcpedit/plugins/dlt_hdlc/hdlc.c
+++ b/src/tcpedit/plugins/dlt_hdlc/hdlc.c
@@ -102,13 +102,12 @@ dlt_hdlc_init(tcpeditdlt_t *ctx)
     }
     
     /* allocate memory for our deocde extra data */
-    if (sizeof(hdlc_extra_t) > 0)
-        ctx->decoded_extra = safe_malloc(sizeof(hdlc_extra_t));
+    ctx->decoded_extra_size = sizeof(hdlc_extra_t);
+    ctx->decoded_extra = safe_malloc(ctx->decoded_extra_size);
 
     /* allocate memory for our config data */
-    if (sizeof(hdlc_config_t) > 0)
-        plugin->config = safe_malloc(sizeof(hdlc_config_t));
-
+    plugin->config_size = sizeof(hdlc_config_t);
+    plugin->config = safe_malloc(plugin->config_size);
     config = (hdlc_config_t *)plugin->config;
 
     /* default to unset */
@@ -136,11 +135,13 @@ dlt_hdlc_cleanup(tcpeditdlt_t *ctx)
     if (ctx->decoded_extra != NULL) {
         safe_free(ctx->decoded_extra);
         ctx->decoded_extra = NULL;
+        ctx->decoded_extra_size = 0;
     }
         
     if (plugin->config != NULL) {
         safe_free(plugin->config);
         plugin->config = NULL;
+        plugin->config_size = 0;
     }
 
     return TCPEDIT_OK; /* success */
@@ -159,9 +160,15 @@ dlt_hdlc_parse_opts(tcpeditdlt_t *ctx)
     hdlc_config_t *config;
     assert(ctx);
 
+
     plugin = tcpedit_dlt_getplugin(ctx, dlt_value);
+    if (!plugin)
+        return TCPEDIT_ERROR;
+
     config = plugin->config;
-    
+    if (plugin->config_size < sizeof(*config))
+        return TCPEDIT_ERROR;
+
     if (HAVE_OPT(HDLC_CONTROL)) {
         config->control = (uint16_t)OPT_VALUE_HDLC_CONTROL;
     }
@@ -191,10 +198,14 @@ dlt_hdlc_decode(tcpeditdlt_t *ctx, const u_char *packet, const int pktlen)
     assert(ctx);
     assert(packet);
 
-    if (pktlen < 4)
+    if (pktlen < sizeof(*hdlc))
         return TCPEDIT_ERROR;
     
+    if (ctx->decoded_extra_size < sizeof(*extra))
+        return TCPEDIT_ERROR;
+
     extra = (hdlc_extra_t *)ctx->decoded_extra;
+
     hdlc = (cisco_hdlc_t *)packet;
     
     ctx->proto = hdlc->protocol;
@@ -223,7 +234,10 @@ dlt_hdlc_encode(tcpeditdlt_t *ctx, u_char *packet, int pktlen, _U_ tcpr_dir_t di
     assert(ctx);
     assert(packet);
 
-    if (pktlen < 4)
+    if (pktlen < sizeof(*hdlc))
+        return TCPEDIT_ERROR;
+
+    if (ctx->decoded_extra_size < sizeof(*extra))
         return TCPEDIT_ERROR;
 
     /* Make room for our new l2 header if old l2len != 4 */
@@ -243,8 +257,16 @@ dlt_hdlc_encode(tcpeditdlt_t *ctx, u_char *packet, int pktlen, _U_ tcpr_dir_t di
      */
     hdlc = (cisco_hdlc_t *)packet;
     plugin = tcpedit_dlt_getplugin(ctx, dlt_value);
+    if (!plugin)
+        return TCPEDIT_ERROR;
+
     config = plugin->config;
+    if (plugin->config_size < sizeof(*config))
+        return TCPEDIT_ERROR;
+
     extra = (hdlc_extra_t *)ctx->decoded_extra;
+    if (ctx->decoded_extra_size < sizeof(*extra))
+        return TCPEDIT_ERROR;
 
     /* set the address field */
     if (config->address < 65535) {
diff --git a/src/tcpedit/plugins/dlt_hdlc/hdlc_types.h b/src/tcpedit/plugins/dlt_hdlc/hdlc_types.h
index 5fe7d14fb..4c9c1cd0f 100644
--- a/src/tcpedit/plugins/dlt_hdlc/hdlc_types.h
+++ b/src/tcpedit/plugins/dlt_hdlc/hdlc_types.h
@@ -33,9 +33,14 @@ extern "C" {
  * Example: Ethernet VLAN tag info
  */
 typedef struct {
-    int hdlc; /* set to 1 if values below are filled out */
-    u_int8_t address;
-    u_int8_t control;
+    union {
+        struct {
+            int hdlc; /* set to 1 if values below are filled out */
+            u_int8_t address;
+            u_int8_t control;
+        };
+        u_char packet[MAXPACKET];
+    };
 } hdlc_extra_t;
 
 
diff --git a/src/tcpedit/plugins/dlt_ieee80211/ieee80211.c b/src/tcpedit/plugins/dlt_ieee80211/ieee80211.c
index 945a81a89..cd6ee5d3b 100644
--- a/src/tcpedit/plugins/dlt_ieee80211/ieee80211.c
+++ b/src/tcpedit/plugins/dlt_ieee80211/ieee80211.c
@@ -108,13 +108,13 @@ dlt_ieee80211_init(tcpeditdlt_t *ctx)
         return TCPEDIT_ERROR;
     }
     
-    /* allocate memory for our deocde extra data */
-    if (sizeof(ieee80211_extra_t) > 0)
-        ctx->decoded_extra = safe_malloc(sizeof(ieee80211_extra_t));
+    /* allocate memory for our decode extra data */
+    ctx->decoded_extra_size = sizeof(ieee80211_extra_t);
+    ctx->decoded_extra = safe_malloc(ctx->decoded_extra_size);
 
     /* allocate memory for our config data */
-    if (sizeof(ieee80211_config_t) > 0)
-        plugin->config = safe_malloc(sizeof(ieee80211_config_t));
+    plugin->config_size = sizeof(ieee80211_config_t);
+    plugin->config = safe_malloc(plugin->config_size);
 
     /* FIXME: set default config values here */
 
@@ -140,11 +140,13 @@ dlt_ieee80211_cleanup(tcpeditdlt_t *ctx)
     if (ctx->decoded_extra != NULL) {
         safe_free(ctx->decoded_extra);
         ctx->decoded_extra = NULL;
+        ctx->decoded_extra_size = 0;
     }
         
     if (plugin->config != NULL) {
         safe_free(plugin->config);
         plugin->config = NULL;
+        plugin->config_size = 0;
     }
 
     return TCPEDIT_OK; /* success */
diff --git a/src/tcpedit/plugins/dlt_ieee80211/ieee80211_hdr.c b/src/tcpedit/plugins/dlt_ieee80211/ieee80211_hdr.c
index 8a42ec1a5..090e0ae1b 100644
--- a/src/tcpedit/plugins/dlt_ieee80211/ieee80211_hdr.c
+++ b/src/tcpedit/plugins/dlt_ieee80211/ieee80211_hdr.c
@@ -143,8 +143,6 @@ ieee80211_is_encrypted(tcpeditdlt_t *ctx, const void *packet, const int pktlen)
 u_char *
 ieee80211_get_src(const void *header)
 {
-    ieee80211_hdr_t *addr3;
-    ieee80211_addr4_hdr_t *addr4;
     uint16_t *frame_control, fc;
 
     assert(header);
@@ -152,10 +150,10 @@ ieee80211_get_src(const void *header)
     fc = ntohs(*frame_control);
 
     if (ieee80211_USE_4(fc)) {
-        addr4 = (ieee80211_addr4_hdr_t *)header;
+        ieee80211_addr4_hdr_t *addr4 = (ieee80211_addr4_hdr_t *)header;
         return addr4->addr4;
     } else {
-        addr3 = (ieee80211_hdr_t *)header;
+        ieee80211_hdr_t *addr3 = (ieee80211_hdr_t *)header;
         switch (fc & (ieee80211_FC_TO_DS_MASK + ieee80211_FC_FROM_DS_MASK)) {
             case ieee80211_FC_TO_DS_MASK:
                 return addr3->addr2;
diff --git a/src/tcpedit/plugins/dlt_ieee80211/ieee80211_types.h b/src/tcpedit/plugins/dlt_ieee80211/ieee80211_types.h
index 5f31cee97..b59d3bf27 100644
--- a/src/tcpedit/plugins/dlt_ieee80211/ieee80211_types.h
+++ b/src/tcpedit/plugins/dlt_ieee80211/ieee80211_types.h
@@ -83,8 +83,7 @@ typedef struct {
  * Example: Ethernet VLAN tag info
  */
 typedef struct {
-    /* dummy entry for SunPro compiler which doesn't like empty structs */    
-    int dummy;
+    u_char packet[MAXPACKET];
 } ieee80211_extra_t;
 
 /* 
diff --git a/src/tcpedit/plugins/dlt_jnpr_ether/jnpr_ether.c b/src/tcpedit/plugins/dlt_jnpr_ether/jnpr_ether.c
index 258ac8ac1..ff1708051 100644
--- a/src/tcpedit/plugins/dlt_jnpr_ether/jnpr_ether.c
+++ b/src/tcpedit/plugins/dlt_jnpr_ether/jnpr_ether.c
@@ -117,8 +117,8 @@ dlt_jnpr_ether_init(tcpeditdlt_t *ctx)
     }
     
     /* allocate memory for our config data */
-    if (sizeof(jnpr_ether_config_t) > 0)
-        plugin->config = safe_malloc(sizeof(jnpr_ether_config_t));
+    plugin->config_size = sizeof(jnpr_ether_config_t);
+    plugin->config = safe_malloc(plugin->config_size);
 
     return TCPEDIT_OK; /* success */
 }
@@ -164,6 +164,7 @@ dlt_jnpr_ether_cleanup(tcpeditdlt_t *ctx)
     if (ctx->decoded_extra != NULL) {
         safe_free(ctx->decoded_extra);
         ctx->decoded_extra = NULL;
+        ctx->decoded_extra_size = 0;
     }
     
     if (plugin->config != NULL) {
@@ -171,6 +172,7 @@ dlt_jnpr_ether_cleanup(tcpeditdlt_t *ctx)
         config = (jnpr_ether_config_t *)ctx->encoder->config;
         tcpedit_dlt_cleanup(config->subctx);
         plugin->config = NULL;
+        plugin->config_size = 0;
     }
 
     return TCPEDIT_OK; /* success */
diff --git a/src/tcpedit/plugins/dlt_linuxsll/linuxsll.c b/src/tcpedit/plugins/dlt_linuxsll/linuxsll.c
index 6f50fdb5d..98a9e1597 100644
--- a/src/tcpedit/plugins/dlt_linuxsll/linuxsll.c
+++ b/src/tcpedit/plugins/dlt_linuxsll/linuxsll.c
@@ -103,14 +103,13 @@ dlt_linuxsll_init(tcpeditdlt_t *ctx)
         return TCPEDIT_ERROR;
     }
 
-    /* allocate memory for our deocde extra data */
-    if (sizeof(linuxsll_extra_t) > 0)
-        ctx->decoded_extra = safe_malloc(sizeof(linuxsll_extra_t));
+    /* allocate memory for our decode extra data */
+    ctx->decoded_extra_size = sizeof(linuxsll_extra_t);
+    ctx->decoded_extra = safe_malloc(ctx->decoded_extra_size);
 
     /* allocate memory for our config data */
-    if (sizeof(linuxsll_config_t) > 0)
-        plugin->config = safe_malloc(sizeof(linuxsll_config_t));
-
+    plugin->config_size = sizeof(linuxsll_config_t);
+    plugin->config = safe_malloc(plugin->config_size);
 
     return TCPEDIT_OK; /* success */
 }
@@ -135,11 +134,13 @@ dlt_linuxsll_cleanup(tcpeditdlt_t *ctx)
     if (ctx->decoded_extra != NULL) {
         safe_free(ctx->decoded_extra);
         ctx->decoded_extra = NULL;
+        ctx->decoded_extra_size = 0;
     }
 
     if (plugin->config != NULL) {
         safe_free(plugin->config);
         plugin->config = NULL;
+        plugin->config_size = 0;
     }
 
     return TCPEDIT_OK; /* success */
diff --git a/src/tcpedit/plugins/dlt_linuxsll/linuxsll_types.h b/src/tcpedit/plugins/dlt_linuxsll/linuxsll_types.h
index 7ba5e50d4..00626db3f 100644
--- a/src/tcpedit/plugins/dlt_linuxsll/linuxsll_types.h
+++ b/src/tcpedit/plugins/dlt_linuxsll/linuxsll_types.h
@@ -32,8 +32,7 @@ extern "C" {
  * Example: Ethernet VLAN tag info
  */
 typedef struct {
-    /* dummy entry for SunPro compiler which doesn't like empty structs */    
-    int dummy;
+    u_char packet[MAXPACKET];
 } linuxsll_extra_t;
 
 
diff --git a/src/tcpedit/plugins/dlt_null/null.c b/src/tcpedit/plugins/dlt_null/null.c
index 8477580ea..bf78544a2 100644
--- a/src/tcpedit/plugins/dlt_null/null.c
+++ b/src/tcpedit/plugins/dlt_null/null.c
@@ -140,11 +140,13 @@ dlt_null_cleanup(tcpeditdlt_t *ctx)
     if (ctx->decoded_extra != NULL) {
         safe_free(ctx->decoded_extra);
         ctx->decoded_extra = NULL;
+        ctx->decoded_extra_size = 0;
     }
         
     if (plugin->config != NULL) {
         safe_free(plugin->config);
         plugin->config = NULL;
+        plugin->config_size = 0;
     }
 
     return TCPEDIT_OK; /* success */
diff --git a/src/tcpedit/plugins/dlt_plugins.c b/src/tcpedit/plugins/dlt_plugins.c
index 61e5a1f74..1b1f78b23 100644
--- a/src/tcpedit/plugins/dlt_plugins.c
+++ b/src/tcpedit/plugins/dlt_plugins.c
@@ -443,7 +443,7 @@ tcpedit_dlt_cleanup(tcpeditdlt_t *ctx)
 
     if (ctx->decoded_extra != NULL)
         safe_free(ctx->decoded_extra);
-        
+
     safe_free(ctx);
 }
 
diff --git a/src/tcpedit/plugins/dlt_pppserial/pppserial.c b/src/tcpedit/plugins/dlt_pppserial/pppserial.c
index a037994ad..a140da3fe 100644
--- a/src/tcpedit/plugins/dlt_pppserial/pppserial.c
+++ b/src/tcpedit/plugins/dlt_pppserial/pppserial.c
@@ -162,11 +162,13 @@ dlt_pppserial_cleanup(tcpeditdlt_t *ctx)
     if (ctx->decoded_extra != NULL) {
         safe_free(ctx->decoded_extra);
         ctx->decoded_extra = NULL;
+        ctx->decoded_extra_size = 0;
     }
         
     if (plugin->config != NULL) {
         safe_free(plugin->config);
         plugin->config = NULL;
+        plugin->config_size = 0;
     }
 
     return TCPEDIT_OK; /* success */
diff --git a/src/tcpedit/plugins/dlt_radiotap/radiotap.c b/src/tcpedit/plugins/dlt_radiotap/radiotap.c
index e89a4b86a..7d6443aad 100644
--- a/src/tcpedit/plugins/dlt_radiotap/radiotap.c
+++ b/src/tcpedit/plugins/dlt_radiotap/radiotap.c
@@ -109,13 +109,13 @@ dlt_radiotap_init(tcpeditdlt_t *ctx)
         return TCPEDIT_ERROR;
     }
 
-    /* allocate memory for our deocde extra data */
-    if (sizeof(radiotap_extra_t) > 0)
-        ctx->decoded_extra = safe_malloc(sizeof(radiotap_extra_t));
+    /* allocate memory for our decode extra data */
+    ctx->decoded_extra_size = sizeof(radiotap_extra_t);
+    ctx->decoded_extra = safe_malloc(ctx->decoded_extra_size);
 
     /* allocate memory for our config data */
-    if (sizeof(radiotap_config_t) > 0)
-        plugin->config = safe_malloc(sizeof(radiotap_config_t));
+    plugin->config_size = sizeof(radiotap_config_t);
+    plugin->config = safe_malloc(plugin->config_size);
 
     return TCPEDIT_OK; /* success */
 }
@@ -139,11 +139,13 @@ dlt_radiotap_cleanup(tcpeditdlt_t *ctx)
     if (ctx->decoded_extra != NULL) {
         safe_free(ctx->decoded_extra);
         ctx->decoded_extra = NULL;
+        ctx->decoded_extra_size = 0;
     }
         
     if (plugin->config != NULL) {
         safe_free(plugin->config);
         plugin->config = NULL;
+        plugin->config_size = 0;
     }
 
     return TCPEDIT_OK; /* success */
@@ -188,13 +190,15 @@ dlt_radiotap_decode(tcpeditdlt_t *ctx, const u_char *packet, const int pktlen)
     
     radiolen = dlt_radiotap_l2len(ctx, packet, pktlen);
     data = dlt_radiotap_get_80211(ctx, packet, pktlen, radiolen);
-    
+    if (!data)
+        return TCPEDIT_ERROR;
+
     /* ieee80211 decoder fills out everything */
     rcode = dlt_ieee80211_decode(ctx, data, pktlen - radiolen);
     
     /* need to override the ieee802.11 l2 length result */
     ctx->l2len = dlt_radiotap_80211_l2len(ctx, packet, pktlen);
-    return rcode;
+    return (ctx->l2len > 0) ? rcode : TCPEDIT_ERROR;
 }
 
 /*
@@ -228,6 +232,9 @@ dlt_radiotap_proto(tcpeditdlt_t *ctx, const u_char *packet, const int pktlen)
         return TCPEDIT_ERROR;
 
     radiolen = dlt_radiotap_l2len(ctx, packet, pktlen);
+    if (radiolen < 0 || radiolen > pktlen)
+        return TCPEDIT_ERROR;
+
     data = dlt_radiotap_get_80211(ctx, packet, pktlen, radiolen);
     return dlt_ieee80211_proto(ctx, data, pktlen - radiolen);
 }
@@ -348,8 +355,12 @@ dlt_radiotap_get_80211(tcpeditdlt_t *ctx, const u_char *packet, const int pktlen
     radiotap_extra_t *extra;
     static COUNTER lastpacket = 0;
 
+    if (ctx->decoded_extra_size < sizeof(*extra))
+        return NULL;
+
     extra = (radiotap_extra_t *)(ctx->decoded_extra);
-    if (lastpacket != ctx->tcpedit->runtime.packetnum) {
+    if (pktlen >= radiolen && (pktlen - radiolen) >= sizeof(extra->packet) &&
+            lastpacket != ctx->tcpedit->runtime.packetnum) {
         memcpy(extra->packet, &packet[radiolen], pktlen - radiolen);
         lastpacket = ctx->tcpedit->runtime.packetnum;
     }
diff --git a/src/tcpedit/plugins/dlt_raw/raw.c b/src/tcpedit/plugins/dlt_raw/raw.c
index 4db3a5460..3d6fcb762 100644
--- a/src/tcpedit/plugins/dlt_raw/raw.c
+++ b/src/tcpedit/plugins/dlt_raw/raw.c
@@ -103,13 +103,13 @@ dlt_raw_init(tcpeditdlt_t *ctx)
         return TCPEDIT_ERROR;
     }
 
-    /* allocate memory for our deocde extra data */
-    if (sizeof(raw_extra_t) > 0)
-        ctx->decoded_extra = safe_malloc(sizeof(raw_extra_t));
+    /* allocate memory for our config data */
+    ctx->decoded_extra_size = sizeof(raw_extra_t);
+    ctx->decoded_extra = safe_malloc(ctx->decoded_extra_size);
 
     /* allocate memory for our config data */
-    if (sizeof(raw_config_t) > 0)
-        plugin->config = safe_malloc(sizeof(raw_config_t));
+    plugin->config_size = sizeof(raw_config_t);
+    plugin->config = safe_malloc(plugin->config_size);
 
     return TCPEDIT_OK; /* success */
 }
@@ -134,11 +134,13 @@ dlt_raw_cleanup(tcpeditdlt_t *ctx)
     if (ctx->decoded_extra != NULL) {
         safe_free(ctx->decoded_extra);
         ctx->decoded_extra = NULL;
+        ctx->decoded_extra_size = 0;
     }
         
     if (plugin->config != NULL) {
         safe_free(plugin->config);
         plugin->config = NULL;
+        plugin->config_size = 0;
     }
 
     return TCPEDIT_OK; /* success */
diff --git a/src/tcpedit/plugins/dlt_raw/raw.h b/src/tcpedit/plugins/dlt_raw/raw.h
index e687624db..6b91392db 100644
--- a/src/tcpedit/plugins/dlt_raw/raw.h
+++ b/src/tcpedit/plugins/dlt_raw/raw.h
@@ -41,12 +41,10 @@ u_char *dlt_raw_get_mac(tcpeditdlt_t *ctx, tcpeditdlt_mac_type_t mac, const u_ch
  * Example: Ethernet VLAN tag info
  */
 struct raw_extra_s {
-    /* dummy entry for SunPro compiler which doesn't like empty structs */    
-    int dummy;
+    u_char packet[MAXPACKET];
 };
 typedef struct raw_extra_s raw_extra_t;
 
-
 /* 
  * FIXME: structure to hold any data in the tcpeditdlt_plugin_t->config 
  * Things like: 
diff --git a/src/tcpedit/plugins/dlt_raw/raw_opts.def b/src/tcpedit/plugins/dlt_raw/raw_opts.def
index 987f459dd..a70b3803d 100644
--- a/src/tcpedit/plugins/dlt_raw/raw_opts.def
+++ b/src/tcpedit/plugins/dlt_raw/raw_opts.def
@@ -1 +1 @@
-/* No options for DLT_RAW as it's an decoder only plugin */
+/* No options for DLT_RAW as it's a decoder only plugin */
diff --git a/src/tcpedit/plugins/dlt_user/user.c b/src/tcpedit/plugins/dlt_user/user.c
index 4c2566fcd..061f733df 100644
--- a/src/tcpedit/plugins/dlt_user/user.c
+++ b/src/tcpedit/plugins/dlt_user/user.c
@@ -101,13 +101,15 @@ dlt_user_init(tcpeditdlt_t *ctx)
         return TCPEDIT_ERROR;
     }
     
-    /* allocate memory for our deocde extra data */
-    if (sizeof(user_extra_t) > 0)
-        ctx->decoded_extra = safe_malloc(sizeof(user_extra_t));
+    /* allocate memory for our decode extra data - plus some space for
+     * other DLT decodes
+     */
+    ctx->decoded_extra_size = USER_L2MAXLEN;
+    ctx->decoded_extra = safe_malloc(ctx->decoded_extra_size);
 
     /* allocate memory for our config data */
-    if (sizeof(user_config_t) > 0)
-        plugin->config = safe_malloc(sizeof(user_config_t));
+    plugin->config_size = sizeof(user_config_t);
+    plugin->config = safe_malloc(plugin->config_size);
     
     config = (user_config_t *)plugin->config;
     config->length = -1;
@@ -136,11 +138,13 @@ dlt_user_cleanup(tcpeditdlt_t *ctx)
     if (ctx->decoded_extra != NULL) {
         safe_free(ctx->decoded_extra);
         ctx->decoded_extra = NULL;
+        ctx->decoded_extra_size = 0;
     }
         
     if (plugin->config != NULL) {
         safe_free(plugin->config);
         plugin->config = NULL;
+        plugin->config_size = 0;
     }
 
     return TCPEDIT_OK; /* success */
@@ -160,7 +164,12 @@ dlt_user_parse_opts(tcpeditdlt_t *ctx)
     assert(ctx);
 
     plugin = tcpedit_dlt_getplugin(ctx, dlt_value);
+    if (!plugin)
+        return TCPEDIT_ERROR;
+
     config = plugin->config;
+    if (plugin->config_size < sizeof(*config))
+        return TCPEDIT_ERROR;
 
     /*
      * --user-dlt will override the output DLT type, otherwise we'll use 
@@ -227,7 +236,12 @@ dlt_user_encode(tcpeditdlt_t *ctx, u_char *packet, int pktlen, tcpr_dir_t dir)
         return TCPEDIT_ERROR;
     
     plugin = tcpedit_dlt_getplugin(ctx, dlt_value);
+    if (!plugin)
+        return TCPEDIT_ERROR;
+
     config = plugin->config;
+    if (plugin->config_size < sizeof(*config))
+        return TCPEDIT_ERROR;
 
     /* Make room for our new l2 header if l2len != config->length */
     if (ctx->l2len > config->length) {
@@ -280,7 +294,7 @@ dlt_user_get_layer3(tcpeditdlt_t *ctx, u_char *packet, const int pktlen)
     /* FIXME: Is there anything else we need to do?? */
     l2len = dlt_user_l2len(ctx, packet, pktlen);
 
-    if (pktlen < l2len)
+    if (l2len < 0 || pktlen < l2len)
         return NULL;
 
     return tcpedit_dlt_l3data_copy(ctx, packet, pktlen, l2len);
@@ -321,7 +335,12 @@ dlt_user_l2len(tcpeditdlt_t *ctx, const u_char *packet, const int pktlen)
     assert(packet);
 
     plugin = tcpedit_dlt_getplugin(ctx, dlt_value);
+    if (!plugin)
+        return TCPEDIT_ERROR;
+
     config = plugin->config;
+    if (plugin->config_size < sizeof(*config))
+        return TCPEDIT_ERROR;
 
     return config->length;
 }
diff --git a/src/tcpedit/plugins/dlt_utils.c b/src/tcpedit/plugins/dlt_utils.c
index 3c5f35980..043260f4d 100644
--- a/src/tcpedit/plugins/dlt_utils.c
+++ b/src/tcpedit/plugins/dlt_utils.c
@@ -268,6 +268,7 @@ tcpedit_dlt_copy_decoder_state(tcpeditdlt_t *ctx, tcpeditdlt_t *subctx)
     
     /* just need to copy the ptr */
     ctx->decoded_extra = subctx->decoded_extra;
+    ctx->decoded_extra_size = subctx->decoded_extra_size;
 
     /* 
      * the first decoder should of alraedy specified it's l2len, so we need to
diff --git a/src/tcpedit/plugins_types.h b/src/tcpedit/plugins_types.h
index 4008c4c94..7e64d056c 100644
--- a/src/tcpedit/plugins_types.h
+++ b/src/tcpedit/plugins_types.h
@@ -92,6 +92,7 @@ struct tcpeditdlt_plugin_s {
     tcpeditdlt_l2addr_type_t (*plugin_l2addr_type)(void);
     u_char *(*plugin_get_mac)(tcpeditdlt_t *, tcpeditdlt_mac_type_t, const u_char *, const int);
     void *config; /* user configuration data for the encoder */
+    size_t config_size;
 };
 
 
@@ -126,6 +127,7 @@ struct tcpeditdlt_s {
     int l2len;                              /* set by decoder and updated by encoder */
     u_int16_t proto;                        /* layer 3 proto type?? */
     void *decoded_extra;                    /* any extra L2 data from decoder like VLAN tags */
+    size_t decoded_extra_size;              /* size of decode_extra buffer */
     u_char srcmac[MAX_MAC_LEN];             /* buffers to store the src & dst MAC */
     u_char dstmac[MAX_MAC_LEN];
 };
diff --git a/src/tcpedit/portmap.c b/src/tcpedit/portmap.c
index d65dded58..84663a06d 100644
--- a/src/tcpedit/portmap.c
+++ b/src/tcpedit/portmap.c
@@ -63,7 +63,7 @@ ports2PORT(char *ports)
 {
     tcpedit_portmap_t *portmap = NULL, *portmap_head = NULL, *portmap_last = NULL;
     char *from_s, *to_s, *from_begin, *from_end, *badchar;
-    long from_l, to_l, from_b, from_e, i;
+    long from_l, to_l, i;
     char *token = NULL, *token2 = NULL;
 
     assert(ports);
@@ -107,17 +107,13 @@ ports2PORT(char *ports)
     if (strchr(from_s, '-')) {
         from_begin = strtok_r(from_s, "-", &token2);
         from_end = strtok_r(NULL, "-", &token2);
-        from_b = strtol(from_begin, &badchar, 10);
-        if (strlen(badchar) != 0) {
-            free(portmap);
-            return NULL;
-        }
-        from_e = strtol(from_end, &badchar, 10);
+        long from_b = strtol(from_begin, &badchar, 10);
         if (strlen(badchar) != 0) {
             free(portmap);
             return NULL;
         }
 
+        long from_e = strtol(from_end, &badchar, 10);
         if (from_b > 65535 || from_b < 0 || from_e > 65535 || from_e < 0) {
             free(portmap);
             return NULL;
@@ -131,8 +127,6 @@ ports2PORT(char *ports)
             portmap = portmap->next;
         }
         portmap_last->next = NULL;
-        free(portmap);
-        portmap = portmap_head = NULL;
     }
     /* process a list via +, filling in list[] */
     else if (strchr(from_s, '+')) {
@@ -190,7 +184,7 @@ int
 parse_portmap(tcpedit_portmap_t ** portmap, const char *ourstr)
 {
     tcpedit_portmap_t *portmap_ptr;
-    char *substr = NULL, *ourstrcpy = NULL, *token = NULL;
+    char *substr, *ourstrcpy, *token = NULL;
 
     assert(ourstr);
     ourstrcpy = safe_strdup(ourstr);
diff --git a/src/tcpedit/tcpedit.c b/src/tcpedit/tcpedit.c
index 223a9e07c..b23fadbe1 100644
--- a/src/tcpedit/tcpedit.c
+++ b/src/tcpedit/tcpedit.c
@@ -292,6 +292,16 @@ tcpedit_packet(tcpedit_t *tcpedit, struct pcap_pkthdr **pkthdr,
         }
     }
 
+    /*
+     * fix IP packet lengths in case they are corrupted by TCP segmentation
+     * offload
+     */
+    if (ip_hdr != NULL) {
+        fix_ipv4_length(*pkthdr, ip_hdr);
+    } else if (ip6_hdr != NULL) {
+        fix_ipv6_length(*pkthdr, ip6_hdr);
+    }
+
     /* do we need to fix checksums? -- must always do this last! */
     if ((tcpedit->fixcsum || needtorecalc)) {
         if (ip_hdr != NULL) {
diff --git a/src/tcpliveplay.c b/src/tcpliveplay.c
index 4763f885e..8ab60ecc2 100644
--- a/src/tcpliveplay.c
+++ b/src/tcpliveplay.c
@@ -259,7 +259,7 @@ main(int argc, char **argv)
     /* Start replay by sending the first packet, the SYN, from the schedule */
     else if(sched[0].local){  /* Send first packet*/
         sendpacket(sp, sched[sched_index].packet_ptr, sched[sched_index].pkthdr.len, &sched[sched_index].pkthdr);
-        printf("Sending Local Packet...............	[%d]\n",sched_index+1);
+        printf("Sending Local Packet...............	[%u]\n",sched_index+1);
         sched_index++; /* Proceed in the schedule */
     }
 
@@ -296,8 +296,8 @@ main(int argc, char **argv)
         } */
         /* Do the following if we receive a packet that ACKs for the same ACKing of next packet */
         else if((tcphdr_rprev->th_seq==htonl(sched[sched_index].exp_rseq)) && (tcphdr_rprev->th_ack==htonl(sched[sched_index].exp_rack)) && (size_payload_prev>0)){
-            printf("Received Remote Packet...............	[%d]\n",sched_index+1);
-            printf("Skipping Packet......................	[%d] to Packet [%d]\n",sched_index+1, sched_index+2);
+            printf("Received Remote Packet...............	[%u]\n",sched_index+1);
+            printf("Skipping Packet......................	[%u] to Packet [%u]\n",sched_index+1, sched_index+2);
             printf("Next Remote Packet Expectation met.\nProceeding in replay...\n");
             sched_index++;   
         } 
@@ -383,6 +383,7 @@ main(int argc, char **argv)
     printf("----------------------------------------------------------\n\n");
 
     free(sched);
+    restore_stdin();
     return 0;
 } 
 /*end of main() function*/
@@ -504,7 +505,7 @@ setup_sched(struct tcp_sched* sched){
     }
 
     /*Before sending any packet, setup the schedule with the proper parameters*/
-    while((packet = pcap_next(local_handle,&header))) {
+    while((packet = safe_pcap_next(local_handle,&header))) {
         pkt_counter++; /*increment number of packets seen*/
 
         memcpy(&sched[i].pkthdr, &header, sizeof(struct pcap_pkthdr));
@@ -713,17 +714,16 @@ set_offline_filter(char* file)
 void 
 got_packet(u_char *args, const struct pcap_pkthdr *header, const u_char *packet){
 
-    ether_hdr *etherhdr = NULL; 
-    tcp_hdr *tcphdr = NULL;
-    ipv4_hdr *iphdr = NULL;
+    ether_hdr *etherhdr;
+    tcp_hdr *tcphdr;
+    ipv4_hdr *iphdr;
 
     unsigned int size_ip, size_tcp, size_payload;
     unsigned int flags = 0;
 
     /* This is to get rid of the warning */
     args = NULL;
-    if(args == NULL) header = NULL;
-    if(header == NULL) args = NULL; 
+    header = NULL;
 
     /* Extract and examine recieved packet headers */
     etherhdr = (ether_hdr*)(packet);
@@ -956,7 +956,6 @@ rewrite(input_addr* new_remoteip, struct mac_addr* new_remotemac, input_addr* my
     struct pcap_pkthdr *header;
     pcap_dumper_t *dumpfile;
     input_addr sip;  /* Source IP */ 
-    unsigned int flags;
     int local_packets = 0;
     bool initstep1 = false;  /* keep track of successful handshake step */
     bool warned = false;
@@ -985,7 +984,8 @@ rewrite(input_addr* new_remoteip, struct mac_addr* new_remotemac, input_addr* my
     }
 
     /*Modify each packet's IP & MAC based on the passed args then do a checksum of each packet*/
-    for (pkt_counter = 0; pcap_next_ex(pcap, &header, &packet) > 0; pkt_counter++){
+    for (pkt_counter = 0; safe_pcap_next_ex(pcap, &header, &packet) > 0; pkt_counter++){
+        unsigned int flags;
 
         if (!warned && header->len > header->caplen) {
             fprintf(stderr, "warning: packet capture truncated to %d byte packets\n",
@@ -1188,7 +1188,6 @@ do_checksum_liveplay(u_int8_t *data, int proto, int len) {
     int ip_hl;
     volatile int sum = 0;   // <-- volatile works around a PPC g++ bug
 
-    sum;
     ipv4 = NULL;
 
     ipv4 = (ipv4_hdr *)data;
diff --git a/src/tcpprep.c b/src/tcpprep.c
index 922775e1a..fd1857974 100644
--- a/src/tcpprep.c
+++ b/src/tcpprep.c
@@ -193,8 +193,9 @@ main(int argc, char *argv[])
 
     /* close cache file */
     close(out_file);
-    return 0;
 
+    restore_stdin();
+    return 0;
 }
 
 
@@ -330,7 +331,7 @@ process_raw_packets(pcap_t * pcap)
 
     assert(pcap);
     
-    while ((pktdata = pcap_next(pcap, &pkthdr)) != NULL) {
+    while ((pktdata = safe_pcap_next(pcap, &pkthdr)) != NULL) {
         packetnum++;
 
         dbgx(1, "Packet " COUNTER_SPEC, packetnum);
@@ -338,11 +339,13 @@ process_raw_packets(pcap_t * pcap)
         /* look for include or exclude LIST match */
         if (options->xX.list != NULL) {
             if (options->xX.mode < xXExclude) {
+                /* include list */
                 if (!check_list(options->xX.list, packetnum)) {
                     add_cache(&(options->cachedata), DONT_SEND, 0);
                     continue;
                 }
             }
+            /* exclude list */
             else if (check_list(options->xX.list, packetnum)) {
                 add_cache(&(options->cachedata), DONT_SEND, 0);
                 continue;
@@ -631,9 +634,6 @@ print_stats(const char *file)
     COUNTER pri = 0, sec = 0, nosend = 0;
     
     count = read_cache(&cachedata, file, &comment);
-    if (count > 65535)
-        exit(-1);
-
     for (COUNTER i = 1; i <= count; i ++) {
         int cacheval = check_cache(cachedata, i);
         switch (cacheval) {
diff --git a/src/tcpprep_api.c b/src/tcpprep_api.c
index 39e3f99ef..0a7d9716e 100644
--- a/src/tcpprep_api.c
+++ b/src/tcpprep_api.c
@@ -221,12 +221,12 @@ int
 tcpprep_set_regex(tcpprep_t *ctx, char *value)
 {
     int regex_error;
-    char ebuf[EBUF_SIZE];
 
     assert(ctx);
 
     if ((regex_error = regcomp(&ctx->options->preg, value,
                     REG_EXTENDED|REG_NOSUB))) {
+        char ebuf[EBUF_SIZE];
         regerror(regex_error, &ctx->options->preg, ebuf, EBUF_SIZE);
         tcpprep_seterr(ctx, "Unable to compile regex (%s): %s", value, regex_error);
         return -1;
diff --git a/src/tcpreplay.c b/src/tcpreplay.c
index 159ee80cc..c50a6c4a8 100644
--- a/src/tcpreplay.c
+++ b/src/tcpreplay.c
@@ -60,7 +60,6 @@ main(int argc, char *argv[])
 {
     int i, optct = 0;
     int rcode;
-    char buf[1024];
 
     fflush(NULL);
 
@@ -146,6 +145,8 @@ main(int argc, char *argv[])
     }
 
     if (ctx->stats.bytes_sent > 0) {
+        char buf[1024];
+
         packet_stats(&ctx->stats);
         if (ctx->options->flow_stats)
             flow_stats(ctx);
@@ -157,6 +158,7 @@ main(int argc, char *argv[])
         }
     }
     tcpreplay_close(ctx);
+    restore_stdin();
     return 0;
 }   /* main() */
 
diff --git a/src/tcpreplay_api.c b/src/tcpreplay_api.c
index 98fbb18ec..6292bbf8d 100644
--- a/src/tcpreplay_api.c
+++ b/src/tcpreplay_api.c
@@ -200,7 +200,7 @@ tcpreplay_post_args(tcpreplay_t *ctx, int argc)
 
     if (HAVE_OPT(MAXSLEEP)) {
         options->maxsleep.tv_sec = OPT_VALUE_MAXSLEEP / 1000;
-        options->maxsleep.tv_nsec = (OPT_VALUE_MAXSLEEP % 1000) * 1000;
+        options->maxsleep.tv_nsec = (OPT_VALUE_MAXSLEEP % 1000) * 1000 * 1000;
     }
 
 #ifdef ENABLE_VERBOSE
diff --git a/src/tcprewrite.c b/src/tcprewrite.c
index 7c11dc242..2adfcc456 100644
--- a/src/tcprewrite.c
+++ b/src/tcprewrite.c
@@ -149,6 +149,8 @@ main(int argc, char *argv[])
 #ifdef ENABLE_DMALLOC
     dmalloc_shutdown();
 #endif
+
+    restore_stdin();
     return 0;
 }
 
@@ -256,7 +258,7 @@ rewrite_packets(tcpedit_t *tcpedit, pcap_t *pin, pcap_dumper_t *pout)
      * Keep sending while we have packets or until
      * we've sent enough packets
      */
-    while ((pktconst = pcap_next(pin, pkthdr_ptr)) != NULL) {
+    while ((pktconst = safe_pcap_next(pin, pkthdr_ptr)) != NULL) {
         packetnum++;
         dbgx(2, "packet " COUNTER_SPEC " caplen %d", packetnum, pkthdr.caplen);
 
diff --git a/src/tree.c b/src/tree.c
index 70fc73a17..6d2a6ac0c 100644
--- a/src/tree.c
+++ b/src/tree.c
@@ -232,7 +232,7 @@ tcpr_tree_to_cidr(const int masklen, const int type)
 tcpr_dir_t
 check_ip_tree(const int mode, const unsigned long ip)
 {
-    tcpr_tree_t *node = NULL, *finder = NULL;
+    tcpr_tree_t *node, *finder;
 
     finder = new_tree();
     finder->family = AF_INET;
@@ -629,7 +629,6 @@ ipv6_cmp(const struct tcpr_in6_addr *a, const struct tcpr_in6_addr *b)
 int
 tree_comp(tcpr_tree_t *t1, tcpr_tree_t *t2)
 {
-    int ret;
     if (t1->family > t2->family) {
         dbgx(2, "family %d > %d", t1->family, t2->family);
         return 1;
@@ -660,7 +659,7 @@ tree_comp(tcpr_tree_t *t1, tcpr_tree_t *t2)
     }
 
     if (t1->family == AF_INET6) {
-        ret = ipv6_cmp(&t1->u.ip6, &t1->u.ip6);
+        int ret = ipv6_cmp(&t1->u.ip6, &t1->u.ip6);
         dbgx(2, "cmp(%s, %s) = %d", get_addr2name6(&t1->u.ip6, RESOLVE),
                 get_addr2name6(&t2->u.ip6, RESOLVE), ret);
         return ret;
diff --git a/test/Makefile.am b/test/Makefile.am
index cc5ecf08c..00d2c890d 100644
--- a/test/Makefile.am
+++ b/test/Makefile.am
@@ -16,15 +16,17 @@ TCPBRIDGE=../src/tcpbridge
 EXTRA_DIST = test.pcap test.auto_bridge test.auto_client test.auto_router \
 		test.auto_server test.auto_first test.cidr test.comment test.port test.mac \
 		test.cidr_reverse test.mac_reverse test.regex_reverse \
-		test.prep_config test.primary test.regex test.secondary \
+		test.include_packets test.exclude_packets test.include_source \
+		test.include_dest test.prep_config \
+		test.primary test.regex test.secondary \
 		test.rewrite_seed test.rewrite_portmap test.rewrite_endpoint \
 		test.rewrite_pnat test.rewrite_pad test.rewrite_trunc \
 		test.rewrite_mac test.rewrite_layer2 test.rewrite_config \
 		test.rewrite_skip test.rewrite_dltuser test.rewrite_dlthdlc \
 		test.rewrite_vlandel test.rewrite_efcs test.rewrite_1ttl \
 		test.rewrite_2ttl test.rewrite_3ttl test.rewrite_enet_subsmac \
-		test.rewrite_mtutrunc test.rewrite_mac_seed \
-		test.rewrite_mac_seed_keep test.rewrite_l7fuzzing\
+		test.rewrite_mtutrunc test.rewrite_mac_seed test.rewrite_range_portmap \
+		test.rewrite_mac_seed_keep test.rewrite_l7fuzzing \
 		test2.rewrite_seed test2.rewrite_portmap test2.rewrite_endpoint \
 		test2.rewrite_pnat test2.rewrite_pad test2.rewrite_trunc \
 		test2.rewrite_mac test2.rewrite_layer2 test2.rewrite_config \
@@ -33,7 +35,8 @@ EXTRA_DIST = test.pcap test.auto_bridge test.auto_client test.auto_router \
 		test2.rewrite_mtutrunc test2.rewrite_enet_subsmac \
 		test2.rewrite_2ttl test2.rewrite_3ttl test.rewrite_tos test2.rewrite_tos \
 		test2.rewrite_enet_subsmac test2.rewrite_mac_seed \
-		test2.rewrite_mac_seed_keep test2.rewrite_l7fuzzing
+		test2.rewrite_range_portmap test2.rewrite_mac_seed_keep \
+		test2.rewrite_l7fuzzing
 
 test: all
 all: clearlog check tcpprep tcpreplay tcprewrite
@@ -57,29 +60,34 @@ standard: standard_prep $(STANDARD_REWRITE)
 	$(PRINTF) "Warning: only creating %s endian standard test files\n" $(REWRITE_WARN)
 
 standard_prep:
-	$(TCPPREP) -i test.pcap -o test.auto_router -a router
+	$(TCPPREP) -i test.pcap -o test.auto_router -a router 
 	$(TCPPREP) -i test.pcap -o test.auto_bridge -a bridge
 	$(TCPPREP) -i test.pcap -o test.auto_client -a client
 	$(TCPPREP) -i test.pcap -o test.auto_server -a server
 	$(TCPPREP) -i test.pcap -o test.auto_first -a first
 	$(TCPPREP) --load-opts config -o test.prep_config
 	$(TCPPREP) -i test.pcap -o test.port -p
-	$(TCPPREP) -i test.pcap -o test.mac -e 00:02:3b:00:3d:ce
-	$(TCPPREP) -i test.pcap -o test.cidr -c '216.27.178.0/24'
-	$(TCPPREP) -i test.pcap -o test.regex -r '216.27.178.*'
+	$(TCPPREP) -i test.pcap -o test.mac -e 00:1f:f3:3c:e1:13
+	$(TCPPREP) -i test.pcap -o test.cidr -c '96.17.211.0/24'
+	$(TCPPREP) -i test.pcap -o test.regex -r '96.17.211.*'
 	$(TCPPREP) -i test.pcap -o test.comment -C "This is a comment" -p
-	$(TCPPREP) -i test.pcap -o test.mac_reverse -e 00:02:3b:00:3d:ce --reverse
-	$(TCPPREP) -i test.pcap -o test.cidr_reverse -c '216.27.178.0/24' --reverse
-	$(TCPPREP) -i test.pcap -o test.regex_reverse -r '216.27.178.*' --reverse
+	$(TCPPREP) -i test.pcap -o test.mac_reverse -e 00:1f:f3:3c:e1:13 --reverse
+	$(TCPPREP) -i test.pcap -o test.cidr_reverse -c '96.17.211.0/24' --reverse
+	$(TCPPREP) -i test.pcap -o test.regex_reverse -r '96.17.211.*' --reverse
+	$(TCPPREP) -i test.pcap -o test.exclude_packets -c '96.17.211.0/24' --exclude 'P:61-65,88-91'
+	$(TCPPREP) -i test.pcap -o test.include_packets -c '96.17.211.0/24' --include 'P:61-65,88-91'
+	$(TCPPREP) -i test.pcap -o test.include_source -c '96.17.211.0/24' --include 'S:96.0.0.0/8'
+	$(TCPPREP) -i test.pcap -o test.include_dest -c '96.17.211.0/24' --include 'D:96.0.0.0/8'
 
 standard_bigendian:
 	$(TCPREWRITE) -i test.pcap -o test.rewrite_seed -s 55
 	$(TCPREWRITE) -i test.pcap -o test.rewrite_tos --tos=50
 	$(TCPREWRITE) -i test.pcap -o test.rewrite_portmap -r 80:8080
+	$(TCPREWRITE) -i test.pcap -o test.rewrite_range_portmap -r 1-100:49148
 	$(TCPREWRITE) -i test.pcap -o test.rewrite_endpoint \
 		-e 10.10.0.1:10.10.0.2 -c test.auto_router
 	$(TCPREWRITE) -i test.pcap -o test.rewrite_pnat \
-		-N 216.27.178.0/24:172.16.0.0/24
+		-N 96.17.211.0/24:172.16.0.0/24
 	$(TCPREWRITE) -i test.pcap -o test.rewrite_pad -F pad
 	$(TCPREWRITE) -i test.pcap -o test.rewrite_trunc -F trunc
 	$(TCPREWRITE) -i test.pcap -o test.rewrite_mac \
@@ -116,10 +124,11 @@ standard_littleendian:
 	$(TCPREWRITE) -i test.pcap -o test2.rewrite_seed -s 55
 	$(TCPREWRITE) -i test.pcap -o test2.rewrite_tos --tos=50
 	$(TCPREWRITE) -i test.pcap -o test2.rewrite_portmap -r 80:8080
+	$(TCPREWRITE) -i test.pcap -o test2.rewrite_range_portmap -r 1-100:49148	
 	$(TCPREWRITE) -i test.pcap -o test2.rewrite_endpoint \
 		-e 10.10.0.1:10.10.0.2 -c test.auto_router
 	$(TCPREWRITE) -i test.pcap -o test2.rewrite_pnat \
-		-N 216.27.178.0/24:172.16.0.0/24
+		-N 96.17.211.0/24:172.16.0.0/24
 	$(TCPREWRITE) -i test.pcap -o test2.rewrite_pad -F pad
 	$(TCPREWRITE) -i test.pcap -o test2.rewrite_trunc -F trunc
 	$(TCPREWRITE) -i test.pcap -o test2.rewrite_mac \
@@ -154,13 +163,15 @@ standard_littleendian:
 
 tcpprep: auto_router auto_bridge auto_client auto_server auto_first cidr regex \
 	port mac comment print_info print_comment prep_config \
-	mac_reverse cidr_reverse regex_reverse
+	mac_reverse cidr_reverse regex_reverse exclude_packets \
+	include_packets include_source include_dest
 
-tcprewrite: rewrite_portmap rewrite_endpoint rewrite_pnat rewrite_trunc \
-	rewrite_pad rewrite_seed rewrite_mac rewrite_layer2 rewrite_config \
-	rewrite_skip rewrite_dltuser rewrite_dlthdlc rewrite_vlandel rewrite_efcs \
-	rewrite_1ttl rewrite_2ttl rewrite_3ttl rewrite_tos rewrite_mtutrunc \
-	rewrite_enet_subsmac rewrite_mac_seed rewrite_mac_seed_keep rewrite_l7fuzzing
+tcprewrite: rewrite_portmap rewrite_range_portmap rewrite_endpoint \
+	rewrite_pnat rewrite_trunc rewrite_pad rewrite_seed rewrite_mac \
+	rewrite_layer2 rewrite_config rewrite_skip rewrite_dltuser rewrite_dlthdlc \
+	rewrite_vlandel rewrite_efcs rewrite_1ttl rewrite_2ttl rewrite_3ttl \
+	rewrite_tos rewrite_mtutrunc rewrite_enet_subsmac rewrite_mac_seed \
+	rewrite_mac_seed_keep rewrite_l7fuzzing
 
 tcpreplay: replay_basic replay_cache replay_pps replay_rate replay_top \
 	replay_config replay_multi replay_pps_multi replay_precache \
@@ -211,14 +222,14 @@ auto_first:
 regex:
 	$(PRINTF) "%s" "[tcpprep] Regex mode test: "
 	$(PRINTF) "%s\n" "*** [tcpprep] Regex mode test: " >>test.log
-	$(TCPPREP) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 -r '216.27.178.*' >>test.log 2>&1
+	$(TCPPREP) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 -r '96.17.211.*' >>test.log 2>&1
 	diff  test.$@ test.$@1 >>test.log 2>&1
 	if [ $? ] ; then $(PRINTF) "\t\t\t%s\n" "FAILED"; else $(PRINTF) "\t\t\t%s\n" "OK"; fi
 
 cidr:
 	$(PRINTF) "%s" "[tcpprep] CIDR mode test: "
 	$(PRINTF) "%s\n" "*** [tcpprep] CIDR mode test: " >>test.log
-	$(TCPPREP) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 -c '216.27.178.0/24' >>test.log 2>&1
+	$(TCPPREP) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 -c '96.17.211.0/24' >>test.log 2>&1
 	diff test.$@ test.$@1 >>test.log 2>&1
 	if [ $? ] ; then $(PRINTF) "\t\t\t%s\n" "FAILED"; else $(PRINTF) "\t\t\t%s\n" "OK"; fi
 
@@ -232,7 +243,7 @@ port:
 mac:
 	$(PRINTF) "%s" "[tcpprep] MAC mode test: "
 	$(PRINTF) "%s\n" "*** [tcpprep] MAC mode test: " >>test.log
-	$(TCPPREP) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 -e 00:02:3b:00:3d:ce >>test.log 2>&1
+	$(TCPPREP) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 -e 00:1f:f3:3c:e1:13 >>test.log 2>&1
 	diff test.$@ test.$@1 >>test.log 2>&1
 	if [ $? ] ; then $(PRINTF) "\t\t\t%s\n" "FAILED"; else $(PRINTF) "\t\t\t%s\n" "OK"; fi
 
@@ -258,24 +269,52 @@ print_info:
 regex_reverse:
 	$(PRINTF) "%s" "[tcpprep] Regex reverse mode test: "
 	$(PRINTF) "%s\n" "*** [tcpprep] Regex reverse mode test: " >>test.log
-	$(TCPPREP) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 -r '216.27.178.*' --reverse >>test.log 2>&1
+	$(TCPPREP) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 -r '96.17.211.*' --reverse >>test.log 2>&1
 	diff  test.$@ test.$@1 >>test.log 2>&1
 	if [ $? ] ; then $(PRINTF) "\t\t%s\n" "FAILED"; else $(PRINTF) "\t\t%s\n" "OK"; fi
 
 cidr_reverse:
 	$(PRINTF) "%s" "[tcpprep] CIDR reverse mode test: "
 	$(PRINTF) "%s\n" "*** [tcpprep] CIDR reverse mode test: " >>test.log
-	$(TCPPREP) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 -c '216.27.178.0/24' --reverse >>test.log 2>&1
+	$(TCPPREP) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 -c '96.17.211.0/24' --reverse >>test.log 2>&1
 	diff test.$@ test.$@1 >>test.log 2>&1
 	if [ $? ] ; then $(PRINTF) "\t\t%s\n" "FAILED"; else $(PRINTF) "\t\t%s\n" "OK"; fi
 
 mac_reverse:
 	$(PRINTF) "%s" "[tcpprep] MAC reverse mode test: "
 	$(PRINTF) "%s\n" "*** [tcpprep] MAC reverse mode test: " >>test.log
-	$(TCPPREP) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 -e 00:02:3b:00:3d:ce --reverse >>test.log 2>&1
+	$(TCPPREP) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 -e 00:1f:f3:3c:e1:13 --reverse >>test.log 2>&1
 	diff test.$@ test.$@1 >>test.log 2>&1
 	if [ $? ] ; then $(PRINTF) "\t\t%s\n" "FAILED"; else $(PRINTF) "\t\t%s\n" "OK"; fi
 
+exclude_packets:
+	$(PRINTF) "%s" "[tcpprep] exclude packets test: "
+	$(PRINTF) "%s\n" "*** [tcpprep] exclude packets test: " >>test.log
+	$(TCPPREP) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 -c '96.17.211.0/24' --exclude 'P:61-65,88-91' >>test.log 2>&1
+	diff test.$@ test.$@1 >>test.log 2>&1
+	if [ $? ] ; then $(PRINTF) "\t\t%s\n" "FAILED"; else $(PRINTF) "\t\t%s\n" "OK"; fi
+	
+include_packets:
+	$(PRINTF) "%s" "[tcpprep] include packets test: "
+	$(PRINTF) "%s\n" "*** [tcpprep] include packets test: " >>test.log
+	$(TCPPREP) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 -c '96.17.211.0/24' --include 'P:61-65,88-91' >>test.log 2>&1
+	diff test.$@ test.$@1 >>test.log 2>&1
+	if [ $? ] ; then $(PRINTF) "\t\t\t%s\n" "FAILED"; else $(PRINTF) "\t\t%s\n" "OK"; fi
+	
+include_source:
+	$(PRINTF) "%s" "[tcpprep] include source test: "
+	$(PRINTF) "%s\n" "*** [tcpprep] include source test: " >>test.log
+	$(TCPPREP) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 -c '96.17.211.0/24' --include 'S:96.0.0.0/8' >>test.log 2>&1
+	diff test.$@ test.$@1 >>test.log 2>&1
+	if [ $? ] ; then $(PRINTF) "\t\t%s\n" "FAILED"; else $(PRINTF) "\t\t\t%s\n" "OK"; fi
+	
+include_dest:
+	$(PRINTF) "%s" "[tcpprep] include destination test: "
+	$(PRINTF) "%s\n" "*** [tcpprep] include destination test: " >>test.log
+	$(TCPPREP) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 -c '96.17.211.0/24' --include 'D:96.0.0.0/8' >>test.log 2>&1
+	diff test.$@ test.$@1 >>test.log 2>&1
+	if [ $? ] ; then $(PRINTF) "\t\t%s\n" "FAILED"; else $(PRINTF) "\t\t%s\n" "OK"; fi
+	
 replay_basic:
 	$(PRINTF) "%s" "[tcpreplay] Basic test: "
 	$(PRINTF) "%s\n" "*** [tcpreplay] Basic test: " >>test.log
@@ -311,6 +350,17 @@ else
 endif
 	if [ $? ] ; then $(PRINTF) "\t\t\t%s\n" "FAILED"; else $(PRINTF) "\t\t\t%s\n" "OK"; fi
 
+rewrite_range_portmap:
+	$(PRINTF) "%s" "[tcprewrite] Portmap range test: "
+	$(PRINTF) "%s\n" "*** [tcprewrite] Portmap range test: " >>test.log
+	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 -r 1-100:49148 >>test.log 2>&1
+if WORDS_BIGENDIAN
+	diff test.$@ test.$@1 >>test.log 2>&1
+else
+	diff test2.$@ test.$@1 >>test.log 2>&1
+endif
+	if [ $? ] ; then $(PRINTF) "\t\t\t%s\n" "FAILED"; else $(PRINTF) "\t\t%s\n" "OK"; fi
+
 rewrite_endpoint:
 	$(PRINTF) "%s" "[tcprewrite] Endpoint test: "
 	$(PRINTF) "%s\n" "*** [tcprewrite] Endpoint test: " >>test.log
@@ -327,7 +377,7 @@ rewrite_pnat:
 	$(PRINTF) "%s" "[tcprewrite] Pseudo NAT test: "
 	$(PRINTF) "%s\n" "*** [tcprewrite] Pseudo NAT test: " >>test.log
 	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 \
-	    -N 216.27.178.0/24:172.16.0.0/24  >>test.log 2>&1
+	    -N 96.17.211.0/24:172.16.0.0/24  >>test.log 2>&1
 if WORDS_BIGENDIAN
 	diff test.$@ test.$@1 >>test.log 2>&1
 else
@@ -359,7 +409,7 @@ if WORDS_BIGENDIAN
 else
 	diff test2.$@ test.$@1 >>test.log 2>&1
 endif
-	if [ $? ] ; then $(PRINTF) "\t\t\t%s\n" "FAILED"; else $(PRINTF) "\t%s\n" "OK"; fi
+	if [ $? ] ; then $(PRINTF) "\t%s\n" "FAILED"; else $(PRINTF) "\t%s\n" "OK"; fi
 
 rewrite_mac_seed:
 	$(PRINTF) "%s" "[tcprewrite] Seeded MAC test: "
@@ -383,7 +433,7 @@ if WORDS_BIGENDIAN
 else
 	diff test2.$@ test.$@1 >>test.log 2>&1
 endif
-	if [ $? ] ; then $(PRINTF) "\t\t\t%s\n" "FAILED"; else $(PRINTF) "\t\t%s\n" "OK"; fi
+	if [ $? ] ; then $(PRINTF) "\t\t%s\n" "FAILED"; else $(PRINTF) "\t\t%s\n" "OK"; fi
 
 rewrite_trunc:
 	$(PRINTF) "%s" "[tcprewrite] Truncate test: "
@@ -559,13 +609,13 @@ endif
 rewrite_l7fuzzing:
 	$(PRINTF) "%s" "[tcprewrite] L7 fuzzing test: "
 	$(PRINTF) "%s\n" "*** [tcprewrite] L7 fuzzing test: " >>test.log
-	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 --fuzz-seed=42 >>test.log 2>&1
+	$(TCPREWRITE) $(ENABLE_DEBUG) -i test.pcap -o test.$@1 --fuzz-seed=42 --fuzz-factor=2 >>test.log 2>&1
 if WORDS_BIGENDIAN
 	diff test.$@ test.$@1 >>test.log 2>&1
 else
 	diff test2.$@ test.$@1 >>test.log 2>&1
 endif
-	if [ $? ] ; then $(PRINTF) "\t\t%s\n" "FAILED"; else $(PRINTF) "\t\t\t%s\n" "OK"; fi
+	if [ $? ] ; then $(PRINTF) "\t\t\t%s\n" "FAILED"; else $(PRINTF) "\t\t\t%s\n" "OK"; fi
 
 replay_pps:
 	$(PRINTF) "%s" "[tcpreplay] Packets/sec test: "
diff --git a/test/test.cidr b/test/test.cidr
index 5442042e9..51a5783e5 100644
Binary files a/test/test.cidr and b/test/test.cidr differ
diff --git a/test/test.cidr_reverse b/test/test.cidr_reverse
index f6a524b67..ebd45079b 100644
Binary files a/test/test.cidr_reverse and b/test/test.cidr_reverse differ
diff --git a/test/test.exclude_packets b/test/test.exclude_packets
new file mode 100644
index 000000000..20cdb4ea9
Binary files /dev/null and b/test/test.exclude_packets differ
diff --git a/test/test.include_dest b/test/test.include_dest
new file mode 100644
index 000000000..dc0764a08
Binary files /dev/null and b/test/test.include_dest differ
diff --git a/test/test.include_packets b/test/test.include_packets
new file mode 100644
index 000000000..d4620d500
Binary files /dev/null and b/test/test.include_packets differ
diff --git a/test/test.include_source b/test/test.include_source
new file mode 100644
index 000000000..7f60a75af
Binary files /dev/null and b/test/test.include_source differ
diff --git a/test/test.mac b/test/test.mac
index 5442042e9..9f1fc1795 100644
Binary files a/test/test.mac and b/test/test.mac differ
diff --git a/test/test.mac_reverse b/test/test.mac_reverse
index cc7a4f894..10d0c7ca7 100644
Binary files a/test/test.mac_reverse and b/test/test.mac_reverse differ
diff --git a/test/test.regex b/test/test.regex
index 5442042e9..51a5783e5 100644
Binary files a/test/test.regex and b/test/test.regex differ
diff --git a/test/test.rewrite_l7fuzzing b/test/test.rewrite_l7fuzzing
index 42dcee223..acbe8d2a5 100644
Binary files a/test/test.rewrite_l7fuzzing and b/test/test.rewrite_l7fuzzing differ
diff --git a/test/test.rewrite_pnat b/test/test.rewrite_pnat
index 25aab90a0..3ae14b64a 100644
Binary files a/test/test.rewrite_pnat and b/test/test.rewrite_pnat differ
diff --git a/test/test.rewrite_range_portmap b/test/test.rewrite_range_portmap
new file mode 100644
index 000000000..30d62d9da
Binary files /dev/null and b/test/test.rewrite_range_portmap differ
diff --git a/test/test2.rewrite_l7fuzzing b/test/test2.rewrite_l7fuzzing
index 2b06a98ba..13d587e6e 100644
Binary files a/test/test2.rewrite_l7fuzzing and b/test/test2.rewrite_l7fuzzing differ
diff --git a/test/test2.rewrite_pnat b/test/test2.rewrite_pnat
index 2ef0a9c50..f88589b79 100644
Binary files a/test/test2.rewrite_pnat and b/test/test2.rewrite_pnat differ
diff --git a/test/test2.rewrite_range_portmap b/test/test2.rewrite_range_portmap
new file mode 100644
index 000000000..d1e914b6d
Binary files /dev/null and b/test/test2.rewrite_range_portmap differ
